define(['BaseView', 'Model', 'Store', 'UIDialog', 'text!TemplatesActivity', 'text!TemplatesActivityLoadingMore', 'util', 'iScroll'], function(BaseView, models, store, UIDialog, tplActivity, tplActivityLoadingMore, util) {

    var isLogin = util.isLogin();
    var getActivityListsModel = models.getActivityListsModel;
    var userInfoModel = models.userInfoModel;
    var myScroll;
    var popstatus=0;
    var typeid=0;
    var view = BaseView.extend({
        viewName: 'activity',
        _curPage: 1,
        _totalPage: 1,
        events: {
            'click .js_activityItem': 'toActivityDetail',
            'click .js_tabItem': 'toItemPage',
            'click .js_push': 'toPublish',
            'click .js_map': 'toMap',
            'click .js_type': 'toType',
            'click .map_layer':'setCookie',
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },
        onShow: function() {
            this.articleid = this.getArticleId();
            this.typeid = this.getTypeId();
            this.showLoading();
            getActivityListsModel.setParam({
                pageSize: 10,
                curPage: 1,
                article_id: this.articleid || null,
                typeid: this.typeid || null
            });
            getActivityListsModel.excute(function(json) {
                this.hideLoading();
                json.result.typeid = this.typeid;
                for(var m in json.result.data){
                    json.result.data[m].expert.merchant_name = this.substrLen(16, json.result.data[m].expert.merchant_name);
                }
                this.render(_.template(tplActivity)(json.result));
                this.cookieMapLayer();
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.initScroll();
            }, function(msg) {
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }else{
                    this.hideLoading();
                    this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
                }
            }, false, this);
        },
        setCookie:function (){
            var self = this;
            if(Turtle.isInApp){
                window.localStorage.setItem("maplayercookie", 1);
                self.$el.find('.map_layer').css('display','none');
            }else{
                var Days = 30;
                var exp = new Date();
                exp.setTime(exp.getTime() + Days*24*60*60*1000);
                document.cookie = "maplayercookie="+ escape (1) + ";expires=" + exp.toGMTString();
                self.$el.find('.map_layer').css('display','none');
            }

        },
        cookieMapLayer:function(){
            var self = this;
            if(Turtle.isInApp){
                var articlelayercookie = window.localStorage.getItem("maplayercookie");
                if(articlelayercookie){
                    self.$el.find('.map_layer').css('display','none');
                }
            }else{
                var arr,reg=new RegExp("(^| )maplayercookie=([^;]*)(;|$)");
                if(arr=document.cookie.match(reg)){
                    if(unescape(arr[2])){
                        self.$el.find('.map_layer').css('display','none');
                    }
                }
            }
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;

            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage >= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }

            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage < self._totalPage) {
                            getActivityListsModel.setParam({
                                pageSize: 10,
                                curPage: self._curPage + 1,
                                typeid: this.typeid || null
                            });
                            getActivityListsModel.excute(function(json) {
                                for(var m in json.result.data){
                                    json.result.data[m].expert.merchant_name = this.substrLen(16, json.result.data[m].expert.merchant_name);
                                }
                                self.render(_.template(tplActivityLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                if (self._curPage >= self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                            pullUpAction();
                        }
                    }
                });
                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);
            }
            loaded();
        },
        toActivityDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var activityid = zpItem.data('activityid');
            var param = ['activityid=', activityid].join('');
            this.jump(['views/activityview.html?', param, '&from=views/', this.viewName, '.html'].join(''));

            // this.jump('views/ceshi.html');
        },
        toItemPage: function(e) {
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('pagename');
            if (pageName) {
                this.jump(['views/', pageName, '.html?from=views/', this.viewName, '.html'].join(''));
            }
        },
        substrLen: function(len,str){
            var tempStr=str;

            var i=0;
            for(var z=0;z<len;z++){
                if(tempStr.charCodeAt(z)>255){
                    i=i+2;
                }else{
                    i=i+1;
                }
                if(i>=len){
                    tempStr=tempStr.slice(0,(z + 1));
                    break;
                }
            }
            return tempStr;
        },
        toPublish: function(e){
            if (!util.isLogin()) {
                this.jump(['views/login_phone.html?', 'from=views/', this.viewName, '.html'].join(''));
                return;
            }
            this.showLoading();
            userInfoModel.setParam({
                access_token: util.getToken()
            });
            userInfoModel.excute(function(json) {
                this.hideLoading();
                if (json.result.level_id >= 3) {
                    if(json.result.merchant_id >0){
                        if(json.result.merchant_status==1){
                            this.jump(['views/activity_publish.html?', 'from=views/', this.viewName, '.html'].join(''));
                        }else{
                            this.jump(['views/merchant_wait.html?', 'from=views/', this.viewName, '.html'].join(''));
                        }
                    }else{
                        this.jump(['views/merchant_no.html?', 'from=views/', this.viewName, '.html'].join(''));
                    }
                } else {
                    new UIDialog({
                        model: {
                            content: '到达3级才可以发布活动，赶紧去面粉实验室玩游戏提升等级吧'
                        }
                    }).show();
                }
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        toMap: function(e){
            this.jump(['views/activity_map.html?from=views/', this.viewName, '.html'].join(''));
        },
        toType :function(e){
            var zpItem = $(e.currentTarget);
            var typeid = zpItem.data('typeid');
                var url = [ 'views/',this.viewName, '.html?typeid=',typeid,'&from=views/', this.viewName, '.html'].join('');

            if (Turtle.isInApp) {
                if(typeid>0){
                    url = [ 'views/',this.viewName, typeid,'.html?typeid=',typeid,'&from=views/', this.viewName, '.html'].join('');
                }
                $('#tipswinxinbcak').remove();
                $('#activitytypebox').hide();
            }
            this.jump( url);
        },
        /**
         * APP和H5获取的传入值方式不一致
         * @return {number || null} articleid
         */
        getArticleId: function() {
            var sArticleId;
            if (Turtle.isInApp) {
                var muiCurWebview = plus.webview.currentWebview();
                var sParam = muiCurWebview.param; //articleid=209 说明是从文章详情过来的，带有articleIid
                sArticleId = sParam.split('=')[1];
            } else {
                sArticleId = Turtle.getQuery('articleid');
            }
            return parseInt(sArticleId) || null;
        },
        getTypeId : function() {
            var sArticleId = Turtle.getQuery('typeid');

            return parseInt(sArticleId) || null;
        },
        /**
         * APP和H5获取的方式不一致
         * 如果是从文章详情点击相关活动跳过来的就是显示相关活动，否则就是活动
         * @return {string} title文字
         */
        getTitleText: function() {
            var sText;
            if (Turtle.isInApp) {
                var muiCurWebview = plus.webview.currentWebview();
                var sParam = muiCurWebview.param; //articleid=209 说明是从文章详情过来的，带有articleIid
                sText = /articleid=/.test(sParam) ? '相关活动' : "活动";
            } else {
                sText = (Turtle.getQuery('from') == 'views/articleview.html' ? '相关活动' : "活动");
            }
            return sText || '活动';
        },
        getTitleBack:function(){
            var sBack;
            if (Turtle.isInApp) {
                var muiCurWebview = plus.webview.currentWebview();
                var sParam = muiCurWebview.param; //articleid=209 说明是从文章详情过来的，带有articleIid
                sBack = /articleid=/.test(sParam) ? 'icon back2' : "";
            } else {
                sBack = (Turtle.getQuery('from') == 'views/articleview.html' ? 'icon back2' : "");
            }
            return sBack || '';
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: self.getTitleBack(),
                    event: function(event) {
                        var articleid = Turtle.getQuery('articleid');
                        if (articleid) {
                            self.jump(['views/articleview.html?articleid=',articleid,'&from=views/', this.viewName, '.html'].join(''));
                        }
                    }
                }],
                centerHandler: [{
                    title: self.getTitleText(),
                    className: "title"
                }],
                rightHandler: [{
                    value: '筛选',
                    className: "t-screen",
                    event: function(event) {
                        if(popstatus==2){
                            popstatus = 1;
                            $('#tipswinxinbcak').remove();
                            $('#activitytypebox').hide();
                        }else{
                            popstatus = 2;
                            var tipswinxinbcak = document.createElement("div");
                            tipswinxinbcak.id = "tipswinxinbcak";
                            tipswinxinbcak.style.width="100%";
                            tipswinxinbcak.style.height= $(document).height() +'px';
                            tipswinxinbcak.style.top="46px";
                            tipswinxinbcak.style.left="0";
                            tipswinxinbcak.style.backgroundColor="#000000";
                            tipswinxinbcak.style.opacity="0.7";
                            tipswinxinbcak.style.position="fixed";
                            tipswinxinbcak.style.zIndex="998";
                            tipswinxinbcak.onclick = function(){
                                $('#tipswinxinbcak').remove();
                                $('#activitytypebox').hide();
                            }
                            document.body.appendChild(tipswinxinbcak);

                            var tipswinxin = $("#activitytypebox");
                            tipswinxin.show();
                            tipswinxin.onclick = function(){
                                $('#tipswinxinbcak').remove();
                                $('#activitytypebox').hide();
                            }
                        }

                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});