define(['BaseView', 'Model', 'Store', 'text!TemplatesActivityMap', 'util', 'UISlide'], function(BaseView, models, store, tplArticleview,  util, UISlide) {
    var mapmarkobjArr = new Array();
    var idArr = new Array();
    var isLogin = util.isLogin();
    var startPos = {x:0,y:0};
    var endPos={x:0,y:0};
    var getMapMerchantModel = models.getMapMerchantModel;
    var view = BaseView.extend({
        viewName: 'activity_map',
        events: {
            'click .merchantinfo': 'toMerchant'
        },
        toMerchant: function(e){
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('merchantid');

            param = ['merchantid=', pageName].join('');

            this.jump(['views/merchantview.html?', 'merchantid=', pageName, '&from=views/', this.viewName, '.html'].join(''));
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplArticleview)());

            map = new BMap.Map('js_maplist');
            var point = new BMap.Point(116.400244,39.92556);
            map.centerAndZoom(point, 17);
            map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));
            var self = this;
            var geolocation = new BMap.Geolocation();
            geolocation.getCurrentPosition(function(r){
                if(this.getStatus() == BMAP_STATUS_SUCCESS){

                    var myIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/my-position.png", new BMap.Size(21,29));
                    // var mk = new BMap.Marker(r.point);
                    var mk = new BMap.Marker(r.point,{icon:myIcon});
                    // var label = new BMap.Label("您的当前位置",{offset:new BMap.Size(-30,-20)});
                    // mk.setLabel(label);
                    map.addOverlay(mk);

                    map.panTo(r.point);
                }
                self.getMerchantList();
            },{enableHighAccuracy: true})

            map.addEventListener("dragend", function showInfo(){
                $(".merchantinfo").hide();
                self.getMerchantList();
            });

            map.addEventListener("resize", function showInfo(){
                self.getMerchantList();
            });
            this.getMerchantList();
            // mapmarker = new BMap.Marker(point);
            // icon = mapmarker.getIcon();
            // icon.setSize(new BMap.Size(40,40));
            // mapmarker.setIcon(icon);
            // map.addOverlay(mapmarker);

            // var bounds = map.getBounds();
            // var sw = bounds.getSouthWest();
            // var ne = bounds.getNorthEast();
            // var lngSpan = Math.abs(sw.lng - ne.lng);
            // var latSpan = Math.abs(ne.lat - sw.lat);

            // for (var i = 0; i < 10; i++) {
            //     point = new BMap.Point(sw.lng + lngSpan * (Math.random() * 0.7), ne.lat - latSpan * (Math.random() * 0.7));
            //     eval(" mapmarker"+i+" = new BMap.Marker(point);");
            //     eval(" map.addOverlay(mapmarker"+i+");");
            //     var id = i;
            //     (function(id){
            //         eval(" mapmarker"+i+".addEventListener(\"click\", function(){ getInfo(id);})");
            //     })(id)
            // };
        },
        getMerchantList:function(){
            var bs = map.getBounds();   //获取可视区域
            var bssw = bs.getSouthWest();   //可视区域左下角
            var bsne = bs.getNorthEast();
            this.showLoading();
            getMapMerchantModel.setParam({
                 ws:bssw.lng,
                 ys:bssw.lat,
                 we:bsne.lng,
                 ye:bsne.lat
            });
            getMapMerchantModel.excute(function(json) {
                this.hideLoading();
                var myIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/map_icon_search.png", new BMap.Size(13,19));
                var curIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/choosed.png", new BMap.Size(19,29));
                for (var i in json.result) {
                    id = json.result[i].id;
                    eval(" var mapmarkobj =  typeof(mapmarker"+id+")==\"undefined\";");
                    if(mapmarkobj){
                        idArr[i] = id;
                        point = new BMap.Point(json.result[i].posx, json.result[i].posy);
                        eval(" mapmarker"+id+" = new BMap.Marker(point);");
                        eval(" mapmarkobjArr["+id+"] = mapmarker"+id+";");
                        // eval(" icon = mapmarker"+id+".getIcon();");
                        // icon.setSize(new BMap.Size(40,40));
                        eval(" mapmarker"+id+".setIcon(myIcon);");
                        eval(" map.addOverlay(mapmarker"+id+");");
                        flag = '';
                        if(json.result[i].type1 ==1 ){
                            flag +='<span class="span1">　</span>';
                        }
                        if(json.result[i].type2 ==1 ){
                            flag +='<span class="span2">　</span>';
                        }
                        if(json.result[i].type3 ==1 ){
                            flag +='<span class="span3">　</span>';
                        }
                        $("#main").append('<div class="merchantinfo" id="merchantinfo'+json.result[i].id+'" data-merchantid="'+json.result[i].id+'"><div class="sta">'+ flag +'</div><img class="logo" src="'+json.result[i].logoimage+'"><div class="name">'+json.result[i].name+'</div><div class="address"> '+json.result[i].address+'</div><img class="ico_tp" src="'+Turtle.baseUrl+'/../resource/images/btn_right.png"></div>');

                        (function(result){
                            eval(" merchantinfo"+id+".addEventListener(\"touchstart\", function(event){ start(event);})");
                            eval(" merchantinfo"+id+".addEventListener(\"touchmove\", function(event){ moving(event);})");
                            eval(" merchantinfo"+id+".addEventListener(\"touchend\", function(event){ end(event,result,idArr,myIcon,curIcon);})");
                            eval(" mapmarker"+id+".addEventListener(\"click\", function(){ getInfo(result,myIcon,curIcon);})");
                        })(json.result[i])
                    }
                };

            }, function(msg) {
                this.hideLoading();

                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: "",
                    className: ""
                }],
                rightHandler: [{
                    value: '列表模式',
                    className: "t-list",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
    function getInfo(jsonObj,myIcon,curIcon){
        $(".merchantinfo").hide();
        $("#merchantinfo"+jsonObj.id).show();
        // var myIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/map_icon_search.png", new BMap.Size(13,19));
        // var curIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/choosed.png", new BMap.Size(19,29));
        for (var j in mapmarkobjArr) {
            mapmarkobjArr[j].setIcon(myIcon);
        }
        eval(" mapmarker"+jsonObj.id+".setIcon(curIcon);");
    }
    function start(event){
        var touch = event.targetTouches[0]; //touches数组对象获得屏幕上所有的touch，取第一个touch
    　　startPos = {x:touch.pageX,y:touch.pageY,time:+new Date}; //取第一个touch的坐标值
    　　isScrolling = 0; //这个参数判断是垂直滚动还是水平滚动
    }
    function moving(event){
        if(event.targetTouches.length > 1 || event.scale && event.scale !== 1) return;
        var touch = event.targetTouches[0];
        endPos = {x:touch.pageX - startPos.x,y:touch.pageY - startPos.y};
        isScrolling = Math.abs(endPos.x) < Math.abs(endPos.y) ? 1:0;    //isScrolling为1时，表示纵向滑动，0为横向滑动
        if(isScrolling === 0){
            event.preventDefault();      //阻止触摸事件的默认行为，即阻止滚屏
        }
    }
    function end(event,jsonObj,id,myIcon,curIcon){
        for (var z in id) {
            if(jsonObj.id==id[z]){
                if(z==0){
                    p = 0;
                }else{
                    p = z-1;
                }
                n = Number(z) + Number(1);
            }
        }
        if(endPos.x > 40 ){
            for (var j in mapmarkobjArr) {
                mapmarkobjArr[j].setIcon(myIcon);
            }
            eval(" var typeId =  typeof("+id[p]+")==\"undefined\";");
            if(typeId){
                id[p] = jsonObj.id;
            }
            $(".merchantinfo").hide();
            $("#merchantinfo"+id[p]).show();
            eval(" mapmarker"+id[p]+".setIcon(curIcon);");
            map.panTo(eval(" mapmarker"+id[p]+".getPosition()"));
        }else if(endPos.x < -40 ){
            for (var j in mapmarkobjArr) {
                mapmarkobjArr[j].setIcon(myIcon);
            }
            eval(" var typeId =  typeof("+id[n]+")==\"undefined\";");
            if(typeId){
                id[n] = jsonObj.id;
            }
            $(".merchantinfo").hide();
            $("#merchantinfo"+id[n]).show();
            eval(" mapmarker"+id[n]+".setIcon(curIcon);");
            map.panTo(eval(" mapmarker"+id[n]+".getPosition()"));
        }
        startPos = {x:0,y:0};
        endPos={x:0,y:0};
    }

});