define(['BaseView', 'Model', 'Store', 'SelectDate', 'UIDialog', 'text!TemplatesActivityPublish', 'util', 'utilCropImage', ], function(BaseView, models, store, SelectDate, UIDialog, tplActivityPublish, util, utilCropImage) {

    var provinceList = {},
        cityList = {},
        areaList = {};

    var isLogin = util.isLogin();
    var getActivityPublish = models.getActivityPublishModel,
        uploadPhotoModel = models.uploadPhotoModel,
        getBaseAreas = models.getBaseAreas;

    if (isLogin) {
        getActivityPublish.url = getActivityPublish.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var param = {
        discount_type : 0,
        activity_type : 0,
        start_time : new Date(),
        end_time : new Date(),
        reg_end_time : new Date()
    };
    var msg = [];
    var now = (function() {
        var arr = [],
        	d = new Date(),
            year = d.getFullYear(),
            month = d.getMonth(),
            day = d.getDate(),
            hours = d.getHours(),
            minutes = d.getMinutes();
        return {
        	year: year,
        	month: month,
        	day: day,
            hours: hours,
            minutes :minutes
        };
    }());

    var view = BaseView.extend({
        viewName: 'activity_publish',
        events: {
            'click .js_discount_type' :'selectDiscountType',
            'click .js_activity_type':'selectActivityType',
            'click #js_send': 'sendActivity',
            'click .tu .close': 'removeImg'
        },

        selectDiscountType: function(e){
            $('.js_discount_type').removeClass("checked");
            $(e.currentTarget).addClass("checked");

            param.discount_type = $(e.currentTarget).data("id");
        },
        selectActivityType: function(e){
            $('.js_activity_type').removeClass("checked");
            $(e.currentTarget).addClass("checked");

            param.activity_type = $(e.currentTarget).data("id");
        },
        sendActivity: function(e) {
            var self = this;

            tuflag  = true;
            var zpItems = $('.tu');
            var aImgUrls = [];
            zpItems.each(function() {
                if ($(this).data('url')) {
                    tuflag  = false;
                    aImgUrls.push($(this).data('url'));
                }
            });
            param.access_token = util.getToken();
            param.title = $.trim($("#title").val());
            param.address = $.trim($("#address").val());
            param.content = $.trim($("#content").val());

            param.discount_number = 1;
            if(param.discount_type == 2 ){
                param.discount_number = parseInt($("#discount_number2").val());
            }else if(param.discount_type == 3 ){
                param.discount_number = parseInt($("#discount_number3").val());
            }

            if(param.activity_type == 1 ){
                param.activity_number = parseInt($("#activity_number1").val());
            }else if(param.activity_type == 2 ){
                param.activity_number = parseInt($("#activity_number2").val());
            }

            if(isNaN(param.activity_number)){
                new UIDialog({
                    model: {
                        content: '请正确填写活动人数'
                    }
                }).show();
            }else if(isNaN(param.discount_number)){
                new UIDialog({
                    model: {
                        content: '请正确填写活动优惠数量'
                    }
                }).show();
            }else if(param.discount_type==0){
                new UIDialog({
                    model: {
                        content: '请选择活动类型'
                    }
                }).show();
            }else if(param.activity_type==0){
                new UIDialog({
                    model: {
                        content: '请选择活动形式'
                    }
                }).show();
            }else if(tuflag){
                new UIDialog({
                    model: {
                        content: '请上传活动图片'
                    }
                }).show();
            }else if(!param.title){
                new UIDialog({
                    model: {
                        content: '请填写活动标题'
                    }
                }).show();
            }else if(!param.address){
                new UIDialog({
                    model: {
                        content: '请填写活动地点'
                    }
                }).show();
            }else if(!param.content){
                new UIDialog({
                    model: {
                        content: '请填写活动内容'
                    }
                }).show();
            }else{
                param.imagelist = aImgUrls;
                param.starttime = param.start_time.getFullYear() + "-"+param.start_time.getMonth() +"-"+param.start_time.getDate() +" "+ param.start_time.getHours()+":"+param.start_time.getMinutes()+":00";
                param.endtime = param.end_time.getFullYear() + "-"+param.end_time.getMonth() +"-"+param.end_time.getDate() +" "+ param.end_time.getHours()+":"+param.end_time.getMinutes()+":00";
                param.regendtime = param.reg_end_time.getFullYear() + "-"+param.reg_end_time.getMonth() +"-"+param.reg_end_time.getDate() +" "+ param.reg_end_time.getHours()+":"+param.reg_end_time.getMinutes()+":00";

                param.province_id = $('#js_select_pcap').val();
                param.city_id = $('#js_select_pcac').val();
                param.district_id = $('#js_select_pcaa').val();


                this.showLoading();
                getActivityPublish.setParam(param);
                getActivityPublish.excute(function(json) {
                    this.hideLoading();
                    this.showToast('发布成功', {
                        hideAction: function() {
                            self.jump('views/activity.html');
                        }
                    });
                }, function(msg) {
                    this.hideLoading();
                    if (_.isObject(msg) && msg.message) {
                        this.showToast(msg.message);
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            }
            // else {
            //     new UIDialog({
            //         model: {
            //             content: msg[0]
            //         }
            //     }).show();
            // }
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            getBaseAreas.excute(function(json) {
                this.hideLoading();

                var i = 0,
                    y = 0;

                provinceList = json.result;

                for (var c in provinceList) {
                    if (i == 0) {
                        cityList = provinceList[c].children_id;
                    }
                    i++;
                }

                for (var a in cityList) {
                    if (y == 0) {
                        areaList = cityList[a].children_id;
                    }
                    y++;
                }

                this.render(_.template(tplActivityPublish)({
                    'now': now,
                    'provinceList': provinceList,
                    'cityList': cityList,
                    'areaList': areaList
                }));

                this._cropImage();

                for (var i = 0; i < 2; i++) {
                    $("<option value='"+(now.year+i)+"'>"+(now.year+i)+"</option>").appendTo($(".js_year"));
                };
                for (var i = 1; i < 13; i++) {
                    if(now.month = i){
                        $("<option value='"+(i)+"' selected>"+(i)+"</option>").appendTo($(".js_month"));
                    }else{
                        $("<option value='"+(i)+"'>"+(i)+"</option>").appendTo($(".js_month"));
                    }
                };

                var dayNumber = getDay(now.year, now.month);
                $(".js_day").data("maxday", dayNumber);
                for (var i = 1; i <= dayNumber; i++) {
                    if(now.day = i){
                        $("<option value='"+(i)+"' selected>"+(i)+"</option>").appendTo($(".js_day"));
                    }else{
                        $("<option value='"+(i)+"'>"+(i)+"</option>").appendTo($(".js_day"));
                    }
                };

                for (var i = 1; i < 24; i++) {
                    if(now.hours = i){
                        $("<option value='"+(i)+"' selected>"+(i)+"</option>").appendTo($(".js_hours"));
                    }else{
                        $("<option value='"+(i)+"'>"+(i)+"</option>").appendTo($(".js_hours"));
                    }
                };

                for (var i = 1; i < 60; i++) {
                    if(now.minutes = i){
                        $("<option value='"+(i)+"' selected>"+(i)+"</option>").appendTo($(".js_minutes"));
                    }else{
                        $("<option value='"+(i)+"'>"+(i)+"</option>").appendTo($(".js_minutes"));
                    }
                };

                $('.line3 .datetime select').on('change', function() {
                    $(this).parent().find("font").html($(this).val());

                    eval("param." + $(this).data("name") +"."+ $(this).data("type")+"("+$(this).val() +"); ");

                    var year = $(this).parent().parent().find(".js_year").val(),
                        month = $(this).parent().parent().find(".js_month").val(),
                        day = $(this).parent().parent().find(".js_day").data("maxday");

                    var dayNumber = getDay(year, month);

                    if(dayNumber > day){
                        for (var i = day+1; i <= dayNumber; i++) {
                            $(this).parent().parent().find(".js_day").append("<option value='"+(i)+"'>"+(i)+"</option>");
                        }
                    }else if(dayNumber < day){
                        nowday = $(this).parent().parent().find(".js_day").val();

                        if(nowday > dayNumber){
                            $(this).parent().parent().find(".js_day").val(dayNumber);
                            $(this).parent().parent().find(".js_day").parent().find("font").html(dayNumber);
                            eval("param." + $(this).parent().parent().find(".js_day").data("name") +".setDate("+dayNumber +"); ");
                        }

                        for (var i = dayNumber+1; i <= day; i++) {
                            $(this).parent().parent().find(".js_day option[value='"+i+"']").remove();
                        }
                    }
                });

                $('#js_select_pcaa').on('change', function() {
                    cityid = $(this).val();
                    $("#pcaa_name").html(areaList[cityid].area_name);
                });

                $('#js_select_pcap').on('change', function() {
                    cityid = $(this).val();
                    cityList = provinceList[cityid].children_id;

                    $("#pcac_name").html(provinceList[cityid].area_name);

                    $("#js_select_pcac option").each(function(){
                        $(this).remove();
                    });
                    _.each(cityList, function(item){
                        $("<option value='"+item.id+"'>"+item.area_name+"</option>").appendTo($("#js_select_pcac"));
                    });

                    y = 0;
                    for (var a in cityList) {
                        if (y == 0) {
                            areaList = cityList[a].children_id;
                        }
                        y++;
                    }

                    $("#js_select_pcaa option").each(function(){
                        $(this).remove();
                    });

                    _.each(areaList, function(item){
                        $("<option value='"+item.id+"'>"+item.area_name+"</option>").appendTo($("#js_select_pcaa"));
                    });
                    z = 0;
                    for (var b in areaList) {
                        if (z == 0) {
                            $("#pcaa_name").html(areaList[b].area_name);
                        }
                        break;
                    }
                });
            }, function() {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        _cropImage: function() {
            var self = this;
            var options = {
                imageBox: '.imageBox',
                thumbBox: '.thumbBox',
                spinner: '.spinner',
                imgSrc: ''
            }
            var cropper;
            this.$el.find('#fileInput').on('change', function() {
                var reader = new FileReader();
                reader.onload = function(e) {
                    options.imgSrc = e.target.result;
                    cropper = new utilCropImage.cropbox(options);
                }
                reader.readAsDataURL(this.files[0]);
                this.files = [];
                self._toggleCrop();

                $(".uploadPage").removeClass("none");
                $(".uploadPage").css("top",$(window).scrollTop());
            });
            $('#btnCrop').on('click', function() {
                var imgBase64 = cropper.getDataURL();
                self.uploadPhoto(imgBase64);
            });
            $('#btnZoomIn').on('click', function() {
                cropper.zoomIn();
            });
            $('#btnZoomOut').on('click', function() {
                cropper.zoomOut();
            });
            $('.js_close').on('click', function() {
                self._toggleCrop();
                self.$el.find('#fileInput').val('');
            });
        },
        _toggleCrop: function() {
            this.$el.find('.js_uploadPage').addClass('none');
        },
        uploadPhoto: function(imgBase64) {
            this.showLoading();
            uploadPhotoModel.setParam({
                file: imgBase64
            });
            uploadPhotoModel.excute(function(json) {
                this.hideLoading();
                this._toggleCrop();
                this.$el.find('#fileInput').val('');
                this._appendImg(imgBase64, json.result);
            }, function(msg) {
                this.hideLoading();

                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        _appendImg: function(imgBase64, sDataUrl) {
            var zpAdd = this.$el.find('.js_add');
            var zpItem = $('<li class="tu" />');
            var zpImg = $('<img/>').attr('src', imgBase64);
            var zpClose = $('<div class="close">-</div>');
            zpItem.data('url', sDataUrl).append(zpImg).append(zpClose);
            zpAdd.before(zpItem);
        },
        removeImg: function(e) {
            var zpClose = $(e.currentTarget);
            zpClose.parent().remove();
        },
        getImgUrls: function() {
            var zpItems = this.$el.find('.js_upload li');
            var aImgUrls = [];
            zpItems.each(function() {
                if ($(this).data('url')) {
                    aImgUrls.push($(this).data('url'));
                }
            });
            return aImgUrls;
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    value: '',
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "发布活动",
                    className: "title"
                }],
                rightHandler: [{}]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
    function getDay(year, month){
        var day = 31;
        if(month == 2){
            if((year%4==0 && year%100!=0)||(year%100==0 && year%400==0)) {
                day = 29;
            }else{
                day = 28;
            }
        }else if(month in [4,6,9,11]){
            day = 30;
        }
        return day;
    }

    function isStrLen(str, cutLen) {
        var result = false,
            num = 0,
            strLen = str.length;

        for (var i = 0; i < strLen; i++) {
            if (str.charCodeAt(i) > 255) {
                num += 2;
            } else {
                num++;
            }
        }

        if (num <= cutLen) {
            result = true;
        }
        return result;
    }
});