define(['BaseView', 'Model', 'Store', 'util', 'utilValidate', 'InputClear', 'text!TemplatesActivitySignup'], function(BaseView, models, store, util, utilValidate, InputClear, tplActivitySignup) {

    var isLogin = util.isLogin();
    var getActivityRegModel = models.getActivityRegModel;
    if (isLogin) {
        getActivityRegModel.url = getActivityRegModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var view = BaseView.extend({
        viewName: 'activity_signup',
        events: {
            'click #js_submit': 'submit'
        },
        submit: function(e) {
            var $elUserName = $('#js_userName'),
                $elTel = $('#js_tel'),
                $elEmail = $('#js_email');
            if(!$elUserName.val()){
                new UIDialog({
                    model: {
                        content: '请输入您的手机号'
                    }
                }).show();
            }else if(!$elTel.val()){
                new UIDialog({
                    model: {
                        content: '请输入您的姓名'
                    }
                }).show();
            }else if(!$elEmail.val()){
                new UIDialog({
                    model: {
                        content: '请填写您的邮箱地址'
                    }
                }).show();
            }else{
                this.showLoading();
                this.activityid = Turtle.getQuery('activityid');
                getActivityRegModel.setParam({
                    activity_id: Turtle.getQuery('activityid'),
                    name: $.trim($elUserName.val()),
                    mobile: $.trim($elTel.val()),
                    email: $.trim($elEmail.val())
                });

                getActivityRegModel.excute(function(json) {
                    var self = this;
                    this.hideLoading();
                    this.showToast('报名成功',{
                        hideAction: function(){
                             // self.jump(['views/activity_signupend.html','?activityid=',self.activityid,'&'].join(''));
                             self.jump(['views/activityview.html','?activityid=',self.activityid,'&from=views/activity.html'].join(''));
                        }
                    });
                }, function(msg) {
                    this.hideLoading();
                    var self = this;
                    if (_.isObject(msg) && msg.message) {
                        this.showToast(msg.message,{
                        hideAction: function(){
                             self.jump('views/activity.html');
                        }
                    });
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            }
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.activityid = Turtle.getQuery('activityid');
            var flourSum = Turtle.getQuery('floursum'),
                flourTotal = Turtle.getQuery('flourtotal');

            this.render(_.template(tplActivitySignup)({'flourSum': flourSum, 'flourTotal': flourTotal}));
            this.hideLoading();
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "我要报名",
                    className: "title"
                }],
                rightHandler: [{}]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});