define(['BaseView', 'Model', 'Store', 'text!TemplatesActivity_survey_form', 'utilValidate', 'utilEncryption'], function(BaseView, models, store, tplActivity_survey_form, utilValidate, utilEncryption) {

    var sendSmsCodeModel = models.sendSmsCodeModel;
    var mobileRegisterModel = models.mobileRegisterModel;
    var getAccessTokenModel = models.getAccessTokenModel;
    var getConfigModel = models.getConfigModel;
    var activityRegLineModel = models.activityRegLineModel;

    var headStore = store.headStore;

    var view = BaseView.extend({
        viewName: 'activity_survey_form',
        _dateTime: null, //从 sys_datetime 获取用做加密用
        _errorMsg: null,
        events: {
           
            
            'click .c_submit_0810': 'sendData',   //提交结果
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {

            
            
            this.render(_.template(tplActivity_survey_form)()); //如上有ajax返回就是 json.result
             //utilValidate.html5Validate(Zepto);
            vFn();
        },

        

        

        sendData:function(){
            
            var oAllData = this.getAllVal();
            var self = this;
            if (this._isAllValValid(oAllData)) {
                this.showLoading();
                activityRegLineModel.setParam(oAllData);
                activityRegLineModel.excute(function(json) {
                    this.hideLoading();
                    //this.showToast('提交成功');
                    
                    this.showToast('提交成功', {

                    'hideSec': 3000,   //延时加载    
                    'hideAction': function() {
                        headStore.setAttr('username', '');
                        headStore.setAttr('token', '');
                        self.jump(['views/activity_survey.html'].join(''));
                    }
                });
                    
                    
                }, function(msg) {
                    this.hideLoading();
                    if (_.isObject(msg) && msg.message) {
                        this.showToast(msg.message);
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            } else {
                this.showToast(this._errorMsg);
            }
        },

       


        //获取用户填写数据
        getAllVal: function() {
            var activityID = '1'; 
            var username = this.$el.find('.a_name').val();
            var mobile = this.$el.find('.a_phone').val();
                mobile = parseInt(mobile);
            var sex = this.$el.find('.a_sex').attr('data');
            var age = this.$el.find('.a_age').val();
                age = parseInt(age);
            var companyName = this.$el.find('.a_company').val();
            var positional = this.$el.find('.a_post').val();

        
            

            return {
                activityID: activityID || null,
                username: username || null,
                mobile: mobile || null,
                sex: sex || null,
                age: age || null,
                companyName: companyName || null,
                positional: positional || null
                
            }
            
        },
       //data validate
       _isAllValValid: function(oAllData) {
            if ((oAllData.username)==null) {
                this._errorMsg = '请输入姓名 ！';
                return false;
            }

            if ((oAllData.mobile)==null) {
                this._errorMsg = '手机号码不能为空 ！';
                return false;
            }
            if (!utilValidate.isMobile(oAllData.mobile)) {
                this._errorMsg = '手机号码格式不正确 ！';
                return false;
            }

            if ((oAllData.age) == null) {
                this._errorMsg = '年龄不能为空！ ';
                return false;
            }
            if (!utilValidate.isAge(oAllData.age)) {
                this._errorMsg = '请您输入18-60之间的阿拉伯数字！';
                return false;
            }

            if ((oAllData.companyName)==null) {
                this._errorMsg = '公司名字不能为空！';
                return false;
            }

            if ((oAllData.positional)==null) {
                this._errorMsg = '您的职位不能为空！';
                return false;
            }
            if (!utilValidate.isChinese(oAllData.positional)) {
                this.showToast('请输入中文职称！');
                return;
            }

            
            return true;
        },

         updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "免费烘培课程报名",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();

    // help

    function vFn(){
        //性别
        $(".sex span").click(function(){
            $(this).addClass("cur_sex").siblings().removeClass("cur_sex");
            var data = $(this).attr("data");
            $(this).parent().attr("data",data);

           // console.log(date);
            })
            
        //职位
        $(".post").click(function(){
            var val= $(this).val();
            //alert(val);
            if(val==""){
                //alert(0)
                $(".post_list").show();
            }else{
                //alert(1)  
                $(".post_list").hide(); 
            }
        });
        $(".post_list span").click(function(){
            var text_1=$(this).html();
            //alert(text_1);
            $(".post").val(text_1);
            $(".post_list").hide();
        }); 
         $(".post").blur(function(){
             var val= $(this).val();
             if(val==""){
                //alert(0)
                $(".post_list").show();
            }else{
                //alert(1)  
                $(".post_list").hide(); 
            }
        });
             
             
        
        //姓名栏失去焦点
        $(".user").blur(function(){
            reg=/^1[3|4|5|8][0-9]\d{4,8}$/i;//验证手机正则(输入前7位至11位)

            if( $(".user").val()=="")
            { 
                $(".user").addClass("errorC");
                $(".error0").html("请输入姓名");
                $(".error0").css("display","block");
            }
            else
            {
                $(".user").addClass("checkedN");
                $(".user").removeClass("errorC");
                $(".error0").css("display","none");
            }
        });
       //手机号栏失去焦点
        $(".phone").blur(function(){
            reg=/^1[3|4|5|8][0-9]\d{4,8}$/i;//验证手机正则(输入前7位至11位)

            if( $(".phone").val()==""|| $(".phone").val()=="请输入您的手机号")
            { 
                $(".phone").addClass("errorC");
                $(".error1").html("请输入您的手机号");
                $(".error1").css("display","block");
            }
            else if($(".phone").val().length<11)
            {   
                $(".phone").addClass("errorC");
                $(".error1").html("手机号码格式不正确");
                $(".error1").css("display","block");
            }
            else if(!reg.test($(".phone").val()))
            {   
                $(".phone").addClass("errorC");
                $(".error1").html("手机号码格式不正确!");
                $(".error1").css("display","block");
            }
            else
            {
                $(".phone").addClass("checkedN");
                $(".phone").removeClass("errorC");
                $(".error1").css("display","none");
            }
        });
        
        //年龄
        // $(".age").blur(function(){
        //     reg=/[0-9]\d{1,2}$/i;//验证年龄

        //     if( $(".age").val()=="")
        //     { 
        //         $(".age").addClass("errorC");
        //         $(".error3").html("请输入您的年龄");
        //         $(".error3").css("display","block");
        //     }
        //     else if($(".age").val()<18 || $(".age").val()>60)
        //     {   
        //         $(".age").addClass("errorC");
        //         $(".error3").html("请您输入18-60之间的阿拉伯数字");
        //         $(".error3").css("display","block");
        //     }
        //     else if(!reg.test($(".age").val()))
        //     {   
        //         $(".phone").addClass("errorC");
        //         $(".error3").html("年龄只能是数字!");
        //         $(".error3").css("display","block");
        //     }
           
        //     else
        //     {
        //         $(".error3").css("display","none");
        //     }
        // });


        //职称
        $(".post").blur(function(){
            reg=/^[\u4e00-\u9fa5]+$/;//验证年龄

             if(!reg.test($(".post").val()))
            {   
                $(".phone").addClass("errorC");
                $(".error5").html("请输入中文职称!");
                $(".error5").css("display","block");
            }
           
            else
            {
                $(".error5").css("display","none");
            }
        });


        

        //提交按钮
        
        // $(".c_submit").click(function(){
            
        //     $(".c_succeed").css("display","block");
        // });
        
        //高度
        var w_hieght=$(window).height();
        //$(".c_from").height(w_hieght);
        $(".c_from").css("min-height",w_hieght);
        
        $(".index_page section").css("min-height",w_hieght);

    }



});



