define(['BaseView', 'Model', 'Store', 'text!TemplatesActivityUnflour'], function(BaseView, models, store, tplActivityUnflour) {

    var view = BaseView.extend({
        viewName: 'activity_unflour',
        events: {
            'click #js_free_flour': 'toGame'
        },
        toGame: function(){
            this.jump('views/game.html');
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            var flourSum = Turtle.getQuery('floursum'),
                flourTotal = Turtle.getQuery('flourtotal');

            this.render(_.template(tplActivityUnflour)({'flourSum': flourSum, 'flourTotal': flourTotal}));
            this.hideLoading();
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "面粉不足",
                    className: "title"
                }],
                rightHandler: [{}]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});