define(['BaseView', 'Model', 'Store', 'UIDialog', 'text!TemplatesActivitycomment', 'text!TemplatesActivitycommentLoadingMore', 'util', 'UISlide', 'iScroll'], function(BaseView, models, store, UIDialog, tplActivity, tplActivityLoadingMore, util, UISlide) {

    var isLogin = util.isLogin();
    var getActivityCommentListModel = models.getActivityCommentListModel;
    var sendActivityCommentModel = models.sendActivityCommentModel;

    var userInfoModel = models.userInfoModel;
    var myScroll;

    var view = BaseView.extend({
        activity_id: 0,
        viewName: 'activitycomment',
        _curPage: 0,
        _totalPage: 1,
        events: {
            'click #js_push': 'toPublish',
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },
        onShow: function() {
            this.activityid = Turtle.getQuery('activityid');
            this.activity_id = Turtle.getQuery('activityid');
            this.showLoading();
            getActivityCommentListModel.setParam({
                pageSize: 10,
                curPage: 0,
                activity_id: this.activityid
            });
            getActivityCommentListModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplActivity)(json.result));
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.initScroll();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;

            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage <= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }

            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage > self._totalPage) {
                            getActivityCommentListModel.setParam({
                                pageSize: 10,
                                curPage: self._curPage,
                                activity_id: self.getActivityId()
                            });
                            getActivityCommentListModel.excute(function(json) {
                                self.render(_.template(tplActivityLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                if (self._curPage == self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                            pullUpAction();
                        }
                    }
                });
                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);
            }
            loaded();
        },
        toPublish: function(e){
            var self = this;
            if (!util.isLogin()) {
                this.jump(['views/login_phone.html?', 'from=views/', this.viewName, '.html'].join(''));
                return;
            }
            var content = $("#commentcontent").val();
            if(!content){
                new UIDialog({
                    model: {
                        content: '请输入评论内容'
                    }
                }).show();
                return;
            }
            this.showLoading();
            sendActivityCommentModel.setParam({
                access_token: util.getToken(),
                commentcontent : content,
                activity_id: self.getActivityId()
            });
            sendActivityCommentModel.excute(function(json) {
                this.hideLoading();
                // if (json.result.level_id >= 3) {
                //     this.jump(['views/activity_publish.html?', 'from=views/', this.viewName, '.html'].join(''));
                // } else {
                new UIDialog({
                    model: {
                        content: '发表成功'
                    }
                }).show();
                this.onShow();

                // }
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        /**
         * APP和H5获取的传入值方式不一致
         * @return {number || null} articleid
         */
        getActivityId : function() {
            var sArticleId = Turtle.getQuery('activityid');

            return parseInt(sArticleId) || null;
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/activityview.html?activityid=',self.activity_id,'&'].join(''));
                        // self.jump(['views/game.html?from=views/', self.viewName, '.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: '评价详情',
                    className: "title"
                }],
                rightHandler: [{
                    value: '',
                    className: "",
                    event: function(event) {

                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});