define(['BaseView', 'Model', 'Store', 'text!TemplatesActivityview', 'util', 'UISlide', 'Swiper'], function(BaseView, models, store, tplActivityview, util, UISlide, Swiper) {

    var getActivityDetailModel = models.getActivityDetailModel;
    var userInfoModel = models.userInfoModel;
    var addressStore = store.addressStore;
    var isLogin = util.isLogin();

    if (isLogin) {
        getActivityDetailModel.url = getActivityDetailModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var view = BaseView.extend({
        viewName: 'activityview',
        activityid: null,
        forShareData: {
            title: null,
            content: null
        },
        events: {
            'click .js_toExpert': 'toExpertDetail',
            'click #js_map': 'toMap',
            'click #js_enroll': 'toSignUp',
            'touchstart .activityview_layer': 'setCookie',
            'click .activityview_layer':'setCookie',
            'click .activityview_layer2':'setCookie',
            'click #js_comment':'toComment'
        },
        toComment: function(e){
            var pageName = this.activityid;

            this.jump(['views/activitycomment.html?activityid=', pageName , '&from=' , 'views/activityview.html?activityid=' , pageName].join(''));
        },
        toExpertDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('merchantid');

            param = ['merchantid=', pageName].join('');

            this.jump(['views/merchantview.html?', 'merchantid=', pageName, '&from=views/', this.viewName, '.html', '?activityid=', this.activityid].join(''));
        },
        toMap: function(e) {
            var from = encodeURIComponent('views/activityview.html?activityid=' + this.activityid);
            // var from = encodeURIComponent('views/merchantview.html?merchantid=' + this.getQuery('merchantid'));
            var zpItem = $(e.currentTarget);
            var posx = zpItem.data('posx');
            var posy = zpItem.data('posy');

            this.jump('views/mapshow.html?posx='+posx+'&posy='+posy+'&activityid='+this.activityid+'&from=' + from);
        },
        toSignUp: function(e) {
            var $el = $(e.currentTarget),
                flourSum = $el.data('flour'),
                from = encodeURIComponent('views/activityview.html?activityid=' + this.getQuery('activityid'));

            if (!util.getToken()) {
                this.jump('views/login_phone.html?from=' + from);
                return;
            }
            this.showLoading();
            userInfoModel.setParam({
                access_token: util.getToken()
            });
            userInfoModel.excute(function(json) {
                this.hideLoading();
                var flourTotal = json.result.flour_total;
                if (json.result.flour_total > flourSum) {
                    this.jump('views/activity_signup.html?activityid=' + this.activityid + '&floursum=' + flourSum + '&flourtotal=' + flourTotal + '&from=' + from);
                } else {
                    this.jump('views/activity_unflour.html?floursum=' + flourSum + '&flourtotal=' + flourTotal + '&from=' + from);
                }
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        render: function(html) {
            this.$el.html(html);
        },
        initSwiper: function(data) {
            var self = this;
            var swiperImg = new Swiper('.swiper-container', {
                nextButton: '.swiper-button-next',
                prevButton: '.swiper-button-prev',
                lazyLoading: true,
                onInit: function(swiper) {
                    self.$el.find('.page_act').text(swiper.activeIndex + 1);
                    self.$el.find('.page_sum').text(swiper.slides.length);
                },
                onSlideChangeEnd: function(swiper) {
                    self.$el.find('.page_act').text(swiper.activeIndex + 1);
                },
                onLazyImageReady: function(swiper){
                    var layerheight = self.$el.find('.merchant').offset().top;
                    self.$el.find('.activityview_layer').css({'height':layerheight,'background':"rgba(0,0,0,0.5)",'z-index': 9999,'position':'absolute','top':'0px','left': '0px'});
                    var layerheight2 = 48+layerheight;
                    self.$el.find('.activityview_layer2').css({'height':'100%','background':"rgba(0,0,0,0.5)",'z-index': 9999,'position':'absolute','top':layerheight2+'px','left': '0px'});
                    self.$el.find('.activityview_layer img').css('display','block');
                    if(Turtle.isInApp){
                        var activityviewcookie = window.localStorage.getItem("activityviewcookie");
                        if(activityviewcookie){
                            self.$el.find('.activityview_layer').css('display','none');
                            self.$el.find('.activityview_layer2').css('display','none');
                        }
                    }else{
                        var arr,reg=new RegExp("(^| )activityviewcookie=([^;]*)(;|$)");
                        if(arr=document.cookie.match(reg)){
                            if(unescape(arr[2])){
                                self.$el.find('.activityview_layer').css('display','none');
                                self.$el.find('.activityview_layer2').css('display','none');
                            }
                        }
                    }
                }
            });
        },
        setCookie:function (){
            var self = this;
            if(Turtle.isInApp){
                window.localStorage.setItem("activityviewcookie", 1);
                self.$el.find('.activityview_layer').css('display','none');
                self.$el.find('.activityview_layer2').css('display','none');
                self.$el.find('.activityview_layer img').css('display','none');
            }else{
                var Days = 30;
                var exp = new Date();
                exp.setTime(exp.getTime() + Days*24*60*60*1000);
                document.cookie = "activityviewcookie="+ escape (1) + ";expires=" + exp.toGMTString();
                self.$el.find('.activityview_layer').css('display','none');
                self.$el.find('.activityview_layer2').css('display','none');
                self.$el.find('.activityview_layer img').css('display','none');
            }

        },
        onShow: function() {
            this.activityid = Turtle.getQuery('activityid');
            this.showLoading();
            getActivityDetailModel.setParam({
                activity_id: this.activityid
            });
            getActivityDetailModel.excute(function(json) {
                this.hideLoading();
                json.result._username = util.getUserName();

                this.render(_.template(tplActivityview)(json.result));


                this.forShareData.title = json.result.title;
                this.forShareData.content = json.result.content;
                addressStore.setAttr('address', json.result.address);
                this.initSwiper(json.result);

            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        showMask: function(opt) {
            var floatw = null,
                extras = opt,
                styles = {
                    'bottom': 0,
                    'width': '100%',
                    'height': '177px',
                    'background': "rgba(0,0,0,0.8)",
                    'scrollIndicator': 'none',
                    'scalable': false,
                    'popGesture': 'none'
                };
            floatw = plus.webview.getWebviewById('mask_layer.html');
            if(!!floatw){
                // floatw = mask_layer.html;
                floatw.show('fade-in', 300);
                floatw = null;
            }else{
                floatw = plus.webview.create('/appviews/mask_layer.html', 'mask_layer.html', styles, extras);
                floatw.addEventListener("loaded", function() {
                    floatw.show('fade-in', 300);
                    floatw = null;
                }, false);
            }

        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        //微信分享外链直接跳进来
                        var fromUrl = self._fromUrlStore.getAttr(self.viewName);
                        if (Turtle.isInApp) {
                            if (Turtle.getQuery('merchantid')) {
                                self.jump(['views/activity.html?merchantid=' + Turtle.getQuery('merchantid')].join(''));
                                return;
                            }
                            mui.back(); // 目前采用直接回退
                        } else {
                            if (fromUrl) {
                                //微信分享外链直接跳进来
                                if (Turtle.getQuery('isshare')) {
                                    self.jump(['views/activity.html'].join(''));
                                    return;
                                }
                                self.jump(fromUrl)
                            } else {
                                self.jump(Turtle.homeUrl);
                            }
                        }
                    }
                }],
                centerHandler: [{
                    title: "活动详情"
                }],
                rightHandler: [{
                    className: Turtle.isInApp ? "icon sharer2" : '',
                    event: function(event) {
                        self.showMask({
                            href: ['http://m.imianfen.com/mobile/views/activityview.html?activityid=', self.activityid, '&isshare=1'].join(''),
                            title: self.forShareData.title,
                            content: self.forShareData.title,
                            imgUrl: ['http://m.imianfen.com/mobile/unpackage/res/icons/144x144.png'],
                            a1:4,
                            a2:self.activityid,
                            a3:util.getToken()
                        });
                    }
                }]
            });
            this.headerView.show();
        }
    });
    this.viewIntance = view.getIntance();
});