define(['BaseView', 'Model', 'Store', 'UIDialog', 'text!TemplatesArticle', 'text!TemplatesArticleLoadingMore', 'util','UISlide','Swiper', 'iScroll'], function(BaseView, models, store, UIDialog, tplArticle, tplArticleLoadingMore, util,UISlide,Swiper) {
    var startPos = {x:0,y:0};
    var endPos={x:0,y:0};
    var isLogin = util.isLogin();
    var headStore = store.headStore;
    var getArticleListsModel = models.getArticleListsModel;
    var articleDeleteModel = models.articleDeleteModel;
    if (isLogin) {
        getArticleListsModel.url = getArticleListsModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
        articleDeleteModel.url = articleDeleteModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var myScroll;

    var view = BaseView.extend({
        viewName: 'article',
        _curPage: 1,
        _totalPage: 1,
        _canJump: true, //为了不感兴趣功能而坐
        events: {
            'click .js_toArticleDetail': 'toArticleDetail',
            'click .js_list': 'forDeleteBtn', //此事件方法必须放在这俩个方法中间，为了Android点击会小时删除按钮而做的修复
            'click #artlist_tap': 'showNoIntest',
            'click .artlist_leftbox': 'hideNoIntest',
            'click .js_tabItem': 'toItemPage',
            'click .lose': 'deleteArticle',
            'click .js_activityItem': 'toActivityDetail',
            'click .artlist_rightcentent': 'toRecipe',
            // 'touchstart #wrapper': 'start',
            // 'touchmove #wrapper': 'moving',
            // 'touchend #wrapper': 'end',
            // 'touchstart .artlist_leftbox': 'navstart',
            // 'touchmove .artlist_leftbox': 'navmoving',
            // 'touchend .artlist_leftbox': 'navend',
            'click .article_layer':'setCookie'
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },

        onShow: function() {


            this.showLoading();
            getArticleListsModel.setParam({
                access_token:util.getToken(),
                pageSize: 10,
                curPage: 1
            });
            getArticleListsModel.excute(function(json) {

                this.hideLoading();

                this.render(_.template(tplArticle)(json.result));
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.cookieRecipeLayer();
                $("#header").css('display','none');

                this.initScroll();
                this.initSwiper(json.result);
            }, function(msg) {
                if (_.isObject(msg) && msg.message) {
                    headStore.setAttr('username', '');
                    headStore.setAttr('token', '');
                    this.jump(['views/article.html'].join(''));
                    return;
                }else{
                    this.hideLoading();
                    this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
                }
            }, false, this);
            this.closeApp(); //APP中实现再按一次后退按钮退出应用
        },
        // navstart:function(event){
        //     var touch = event.targetTouches[0]; //touches数组对象获得屏幕上所有的touch，取第一个touch
        // 　　startPos = {x:touch.pageX,y:touch.pageY,time:+new Date}; //取第一个touch的坐标值
        // 　　isScrolling = 0; //这个参数判断是垂直滚动还是水平滚动
        //     endPos={x:0,y:0};
        // },
        // navmoving:function(event){
        //     if(event.targetTouches.length > 1 || event.scale && event.scale !== 1) return;
        //     var touch = event.targetTouches[0];
        //     endPos = {x:touch.pageX - startPos.x,y:touch.pageY - startPos.y};
        //     isScrolling = Math.abs(endPos.x) < Math.abs(endPos.y) ? 1:0;    //isScrolling为1时，表示纵向滑动，0为横向滑动
        //     if(isScrolling === 0){
        //         event.preventDefault();      //阻止触摸事件的默认行为，即阻止滚屏
        //     }
        // },
        // navend:function(event){
        //     if(endPos.x >40  ){
        //         event.stopPropagation();
        //         event.preventDefault();
        //         this._canJump = true;
        //         var zpItem = $(event.currentTarget);
        //         var zpNoIntest = zpItem.siblings('.artlist_rightnav');
        //         $(".artlist_rightbox").animate({right: '-60%'}, "fast" ,function(){
        //             $('.artlist_rightnav').css('display','none');
        //         });
        //         var rightbox = zpItem.siblings('.artlist_rightbox');
        //         rightbox.show();
        //         zpNoIntest.show();
        //     }
        //     startPos = {x:0,y:0};
        //     endPos={x:0,y:0};
        // },
        setCookie:function (){
            var self = this;
            if(Turtle.isInApp){
                window.localStorage.setItem("articlelayercookie", 1);
                self.$el.find('.article_layer').css('display','none');
            }else{
                var Days = 30;
                var exp = new Date();
                exp.setTime(exp.getTime() + Days*24*60*60*1000);
                document.cookie = "articlelayercookie="+ escape (1) + ";expires=" + exp.toGMTString();
                self.$el.find('.article_layer').css('display','none');
            }

        },
        cookieRecipeLayer:function(){
            var self = this;
            if(Turtle.isInApp){
                var articlelayercookie = window.localStorage.getItem("articlelayercookie");
                if(articlelayercookie){
                    self.$el.find('.article_layer').css('display','none');
                }
            }else{
                var arr,reg=new RegExp("(^| )articlelayercookie=([^;]*)(;|$)");
                if(arr=document.cookie.match(reg)){
                    if(unescape(arr[2])){
                        self.$el.find('.article_layer').css('display','none');
                    }
                }
            }
        },
        showNoIntest: function(e) {
            var self = this;
            e.stopPropagation();
            e.preventDefault();
            this._canJump = true;
            var zpItem = $(e.currentTarget);
            // $.fx.interval = 5;
            $('.artlist_rightnav').css('display','block');
            var zpNoIntest = zpItem.siblings('.artlist_rightnav');
            $(".artlist_rightbox").addClass('sliderightin');
            setTimeout(function(){ //动画结束时重置class
              $(".artlist_rightbox").removeClass('sliderightin');
            }, 300);
            // $(".artlist_rightbox").css('transform','translate3d(0px, 0px, 0px)');
            // $(".artlist_rightbox").animate({right: '0%'},  "fast");
            var rightbox = zpItem.siblings('.artlist_rightbox');
            zpNoIntest.show();
            rightbox.show();
        },
        hideNoIntest:function(e){
            var self = this;
            e.stopPropagation();
            e.preventDefault();
            var zpItem = $(e.currentTarget);
            var zpNoIntest = zpItem.siblings('.artlist_rightnav');
            // $.fx.interval = 5;
            $(".artlist_rightbox").addClass('sliderightout');
            setTimeout(function(){ //动画结束时重置class
              $('.artlist_rightnav').css('display','none')
              $(".artlist_rightbox").removeClass('sliderightout');
            }, 300);
            // $(".artlist_rightbox").animate({right: '-60%'},  "fast",function(){
            //     $('.artlist_rightnav').css('display','none');
            // });
            var rightbox = zpItem.siblings('.artlist_rightbox');
            rightbox.show();
            zpNoIntest.show();


        },
        //很无奈的调整，原先在showNoIntest中用document.one.click事件做的，但是在安卓死活会第一时间触发这个click所以用这个方法绕过去
        forDeleteBtn: function() {
            var deleteBtn = this.$el.find('.lose');
            if (this._canJump == false && deleteBtn.css('display') == 'block') {
                deleteBtn.hide();
                this._canJump = true;
            }
        },
        deleteArticle: function(e) {
            var zpItem = $(e.currentTarget);
            var zpWrap = zpItem.parents('.css_articleItem');
            var zpLink = zpWrap.find('.js_toArticleDetail');
            var articleid = zpLink.data('articleid');
            if (!util.isLogin()) {
                this.jump(['views/login_phone.html?from=views/', this.viewName, '.html'].join(''));
                return;
            }
            this.showLoading();
            articleDeleteModel.setParam({
                article_id: articleid
            });
            articleDeleteModel.excute(function(json) {
                this.hideLoading();
                zpWrap.remove();
                this.showToast('删除成功');
                if (this.$el.find('.css_articleItem').size() == 0) {
                    this.appendMoreItem();
                }
                myScroll.refresh();
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        appendMoreItem: function() {
            var self = this;
            // ajax
            if (self._curPage < self._totalPage) {
                getArticleListsModel.setParam({
                    pageSize: 10,
                    curPage: self._curPage + 1
                });
                getArticleListsModel.excute(function(json) {
                    self.render(_.template(tplArticleLoadingMore)(json.result), self.$el.find('.js_list'));
                    self._curPage = json.result.curPage;
                    self._totalPage = json.result.totalPage;
                    //应该是 == 但是需求是下一次加载是10页一次加载，所以 curPage 和 totoalPage就换了，所以变成 >= 号来前端修复
                    if (self._curPage >= self._totalPage) {
                        self.$el.find('.art_none').removeClass('none');
                    }
                    myScroll.refresh();
                }, function(msg) {
                    console.log('error');
                }, false, self);
            }
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;
            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage >= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }
            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage < self._totalPage) {
                            getArticleListsModel.setParam({
                                pageSize: 10,
                                curPage: self._curPage + 1
                            });
                            getArticleListsModel.excute(function(json) {
                                self.render(_.template(tplArticleLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                //应该是 == 但是需求是下一次加载是10页一次加载，所以 curPage 和 totoalPage就换了，所以变成 >= 号来前端修复
                                if (self._curPage >= self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                            pullUpAction();
                        }
                    }
                });


                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);

            }

            loaded();


        },


        /**
         * 这是一个webview互相伤害的故事2 (仅在APP中产生)
         * 文章页->文章详情页->相关活动页->文章页->文章详情页
         * 同样因为文章详情页的webview没有销毁，所以每次文章详情页都是原先的详情页所以销毁掉
         * @param  {event obj} e event
         */
        toArticleDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var articleid = zpItem.data('articleid');
            var param = ['articleid=', articleid].join('');
            if (this._canJump) {

                this.jump(['views/articleview.html?', param, '&from=views/', this.viewName, '.html'].join(''));
            }
        },
        toActivityDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var activityid = zpItem.data('activityid');
            var param = ['activityid=', activityid].join('');
            this.jump(['views/activityview.html?', param, '&from=views/', this.viewName, '.html'].join(''));
            // this.jump('views/ceshi.html');
        },
        /**
         * 这是一个webview互相伤害的故事1 (仅在APP中产生)
         * 文章页->活动页->文章页->文章详情页->相关活动页(就是活动页参数不同)
         * 因为APP中webview是不会像H5一样销毁的，他仅仅是隐藏，所以每次到活动页得进行判别
         * 如果这个活动页是相关活动页(判别依据就是param是否存在)那么就要销毁相关活动页然后重开，不然就直接打开就行了
         * @param  {event obj} e event
         */
        toItemPage: function(e) {
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('pagename');
            if (pageName && this._canJump) {

                this.jump(['views/', pageName, '.html?from=views/', this.viewName, '.html'].join(''));
            }
        },
        initSwiper: function(data) {
            var self = this;
            var swiperImg = new Swiper('.swiper-container', {
                pagination : '.swiper-pagination',
                autoplayDisableOnInteraction:false,
                autoplay: 2500,
            });
        },
        /**
         * APP中实现再按一次后退按钮退出应用
         * http://ask.dcloud.net.cn/question/249
         */
        closeApp: function() {
            if (Turtle.isInApp) {
                mui.plusReady(function() {
                    //首页返回键处理
                    //处理逻辑：1秒内，连续两次按返回键，则退出应用；
                    var first = null;
                    plus.key.addEventListener('backbutton', function() {
                        //首次按键，提示‘再按一次退出应用’
                        if (!first) {
                            first = new Date().getTime();
                            mui.toast('再按一次退出应用');
                            setTimeout(function() {
                                first = null;
                            }, 1000);
                        } else {
                            if (new Date().getTime() - first < 1000) {
                                plus.runtime.quit();
                            }
                        }
                    }, false);
                });
            }
        },
          /**
         * 这是一个webview互相伤害的故事 (仅在APP中产生)
         * 文章页->文章详情页->相关活动页->文章页->文章详情页
         * 同样因为文章详情页的webview没有销毁，所以每次文章详情页都是原先的详情页所以销毁掉
         * @param  {event obj} e event
         */
        toRecipe: function(e) {
            var zpItem = $(e.currentTarget);
            var typeid = zpItem.data('typeid');
            var param = ['typeid=', typeid].join('');
            // if (this._canJump) {

            this.jump(['views/recipe.html?',param ,'&from=views/', this.viewName, '.html'].join(''));
            // }
        },
    });
    this.viewIntance = view.getIntance();
});



