define(['BaseView', 'Model', 'Store', 'text!TemplatesArticleview', 'util','UISlide', 'Swiper','iScroll'], function(BaseView, models, store, tplArticleview, util,UISlide, Swiper) {

    var getArticleDetailModel = models.getArticleDetailModel;

    var view = BaseView.extend({
        viewName: 'articleview',
        articleid: null,
        nextArticleId: null,
        forShareData: {
            title: null,
            content: null
        },
        events: {
            'click .js_toExpert': 'toExpertDetail',
            'click .js_toBack': 'toBack',
            'click .js_toShare': 'toShare',
            'click .js_toRecipe': 'toRecipe',
            'click .js_relateActivity': 'toRelateActivity'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.articleid = Turtle.getQuery('articleid');
            //给后台预览功能而用
            this.preview = Turtle.getQuery('preview');
            this.showLoading();
            getArticleDetailModel.setParam({
                article_id: this.articleid,
                preview: this.preview ? this.preview : null
            });
            getArticleDetailModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplArticleview)(json.result));
                this.nextArticleId = json.result.next_article_id;
                this.forShareData.title = json.result.title;
                this.forShareData.content = json.result.content;
                this.typeid = json.result.typelist[0].id;
                // this.initSwiper(json.result);
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        toBack:function(e){
            var self = this;
            self.jump(['views/article.html'].join(''));
            // var fromUrl = self._fromUrlStore.getAttr(self.viewName);
            // if (Turtle.isInApp) {
            //     self.jump(['views/article.html'].join(''));
            //     // mui.back(); // 目前采用直接回退
            // } else {
            //     if (fromUrl) {
            //         //微信分享外链直接跳进来
            //         if (Turtle.getQuery('isshare')) {
            //             self.jump(['views/article.html'].join(''));
            //             return;
            //         }
            //         self.jump(fromUrl)
            //     } else {
            //         self.jump(Turtle.homeUrl);
            //     }
            // }
        },
        toRecipe:function(e){
            this.jump(['views/recipe.html?from=views/', this.viewName, '.html'].join(''));
        },
        toShare:function(e){
            var self = this;
            var content = self.forShareData.content;
            self.forShareData.content = content.substr(0,100);
            self.showMask({
                href: ['http://m.imianfen.com/mobile/views/articleview.html?articleid=',self.articleid, '&isshare=1'].join(''),
                title: self.forShareData.title,
                content: self.forShareData.content,
                imgUrl: ['http://m.imianfen.com/mobile/unpackage/res/icons/144x144.png'],
                a1:3,
                a2:self.articleid,
                a3:util.getToken()
            });
        },
        // initSwiper: function(data) {
        //     var self = this;
        //     var swiperImg = new Swiper('.swiper-container', {
        //         nextButton: '.swiper-button-next',
        //         prevButton: '.swiper-button-prev',
        //         lazyLoading: true,
        //         onInit: function(swiper) {
        //             self.$el.find('.page_act').text(swiper.activeIndex + 1);
        //             self.$el.find('.page_sum').text(swiper.slides.length);
        //         },
        //         onSlideChangeEnd: function(swiper) {
        //             self.$el.find('.page_act').text(swiper.activeIndex + 1);
        //         },
        //         //这里使用progress判断，也是一种无奈的方法，原本是使用swiper.isEnd，但是最后会到倒数第二个的时候就跳过去，所以用这个来判断
        //         onTouchEnd: function(swiper) {
        //             if (swiper.progress > 1) {
        //                 self.toNextArticle();
        //             }
        //         }
        //     });
        //     var swiperText = new Swiper('.info-container', {
        //         direction: 'vertical',
        //     });
        //     // $('.swiper-slide').each(function() {
        //     //     var height = $(this).find('p').height();
        //     //     $(this).css({
        //     //         height: height
        //     //     })
        //     // })

        //     swiperImg.params.control = swiperText;
        //     swiperText.params.control = swiperImg;
        // },
        toExpertDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var userid = zpItem.data('userid');
            var username = zpItem.data('username');
            var _param = ['userid=', userid, '&', 'username=', username].join('');
            this.jump(['views/expertview.html?', _param,
                '&from=views/', this.viewName, '.html',
                '?articleid=', this.articleid
            ].join(''));
        },
        toNextArticle: function() {
            var _param = ['articleid=', this.nextArticleId].join('');
            this.jump(['views/articleview.html?', _param, '&from=views/article.html'].join(''));
        },
        /**
         * 这是一个webview互相伤害的故事3 (仅在APP中产生)
         * 文章页->活动页->文章页->文章详情页->相关活动页(就是活动页参数不同)
         * 因为APP中webview是不会像H5一样销毁的，他仅仅是隐藏，所以每次到活动页得进行判别
         * 如果这个活动页是活动页存在(无论是相关活动页还是活动页)销毁活动页然后重开就行
         * @param  {event obj} e event
         */
        toRelateActivity: function() {
            if (Turtle.isInApp) {
                var ws = plus.webview.getWebviewById('views/activity.html');
                plus.webview.close(ws);
            }
            this.jump(['views/activity.html?articleid=', this.articleid, '&from=views/', this.viewName, '.html'].join(''));
        },
        showMask: function(opt) {
            var floatw = null,
                extras = opt,
                styles = {
                    'bottom': 0,
                    'width': '100%',
                    'height': '177px',
                    'background': "rgba(0,0,0,0.8)",
                    'scrollIndicator': 'none',
                    'scalable': false,
                    'popGesture': 'none'
                };

            floatw = plus.webview.create('/appviews/mask_layer.html', 'mask_layer.html', styles, extras);
            floatw.addEventListener("loaded", function() {
                floatw.show('fade-in', 300);
                floatw = null;
            }, false);
        },

        // updateHeader: function() {
        //     var self = this;
        //     this.headerView.set({
        //         view: this,
        //         leftHandler: [{
        //             className: "icon back artback",
        //             event: function(event) {
        //                 var fromUrl = self._fromUrlStore.getAttr(self.viewName);
        //                 if (Turtle.isInApp) {
        //                     mui.back(); // 目前采用直接回退
        //                 } else {
        //                     if (fromUrl) {
        //                         //微信分享外链直接跳进来
        //                         if (Turtle.getQuery('isshare')) {
        //                             self.jump(['views/article.html'].join(''));
        //                             return;
        //                         }
        //                         self.jump(fromUrl)
        //                     } else {
        //                         self.jump(Turtle.homeUrl);
        //                     }
        //                 }
        //             }
        //         }],
        //         centerHandler: [{
        //             title: "文章详情",
        //             className: "title"
        //         }],
        //         rightHandler: [{
        //             className: Turtle.isInApp ? "icon sharer" : '',
        //             event: function(event) {
        //                 self.showMask({
        //                     href: ['http://m.imianfen.com/mobile/views/articleview.html?articleid=', self.articleid, '&isshare=1'].join(''),
        //                     title: self.forShareData.title,
        //                     content: self.forShareData.content,
        //                     imgUrl: ['http://m.imianfen.com/mobile/unpackage/res/icons/144x144.png']
        //                 });
        //             }
        //         }]
        //     });
        //     this.headerView.show();
        // }
    });

    this.viewIntance = view.getIntance();
});