define(['BaseView', 'Model', 'Store', 'text!TemplatesExpert', 'text!TemplatesExpertLoadingMore', 'util', 'iScroll'], function(BaseView, models, store, tplExpert, tplExpertLoadingMore, util) {

    var isLogin = util.isLogin();
    var getExpertListsModel = models.getExpertListsModel;
    var myScroll;

    var view = BaseView.extend({
        viewName: 'expert',
        _curPage: 1,
        _totalPage: 1,
        events: {
            'click .js_expertItem': 'toExpertDetail',
            'click .js_tabItem': 'toItemPage',
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            getExpertListsModel.setParam({
                pageSize: 3,
                curPage: 1,
            });
            getExpertListsModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplExpert)(json.result));
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.initScroll();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;

            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage >= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }

            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage < self._totalPage) {
                            getExpertListsModel.setParam({
                                pageSize: 10,
                                curPage: self._curPage + 1
                            });
                            getExpertListsModel.excute(function(json) {
                                self.render(_.template(tplExpertLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                if (self._curPage == self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                            pullUpAction();
                        }
                    }
                });
                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);
            }
            loaded();
        },
        toExpertDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var userid = zpItem.data('userid');
            var username = zpItem.data('username');
            var param = ['userid=', userid, '&', 'username=', username].join('');
            this.jump(['views/expertview.html?', param, '&from=views/', this.viewName, '.html'].join(''));
        },
        toItemPage: function(e) {
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('pagename');
            if (pageName) {
                this.jump(['views/', pageName, '.html?from=views/', this.viewName, '.html'].join(''));
            }
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon bake",
                    event: function(event) {
                        if (!util.isLogin()) {
                            self.jump(['views/login_phone.html?from=views/', self.viewName, '.html'].join(''));
                            return;
                        }
                        self.jump(['views/game.html?from=views/', self.viewName, '.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: "达人",
                    className: "title"
                }],
                rightHandler: [{}]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});