define(['BaseView', 'Model', 'Store', 'text!TemplatesFeedback', 'util', 'utilValidate'], function(BaseView, models, store, tplFeedback, util, utilValidate) {

    var isLogin = util.isLogin();
    var userFeedbackModel = models.userFeedbackModel;
    var headStore = store.headStore;

    if (isLogin) {
        userFeedbackModel.url = userFeedbackModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var view = BaseView.extend({
        viewName: 'feedback',
        _errorMsg: null,
        events: {
            'focus .js_mail': 'focusMail',
            'blur .js_mail': 'blurMail',
            'click .js_send': 'sendFeecback'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            if (!isLogin) {
                this.jump(['views/login_phone.html', '?from=views/', this.viewName, '.html'].join(''));
                return;
            }
            this.render(_.template(tplFeedback)());
        },
        focusMail: function(e) {
            var zpItem = $(e.currentTarget);
            zpItem.parent().addClass('on');
        },
        blurMail: function(e) {
            var zpItem = $(e.currentTarget);
            zpItem.parent().removeClass('on');
            if (!utilValidate.isEmail(zpItem.val())) {
                this.showToast('请输入有效的Email');
                return false;
            }
        },
        _isAllValValid: function(oAllData) {
            if (!utilValidate.isEmail(oAllData.email)) {
                this._errorMsg = '请输入有效的Email';
                return false;
            }
            if (!_.isString(oAllData.feedback) || oAllData.feedback.length < 10) {
                this._errorMsg = '请至少输入10个字<br>进行反馈';
                return false;
            }
            return true;
        },
        getAllVal: function(oAllData) {
            var email = this.$el.find('.js_mail').val();
            var feedback = this.$el.find('.js_feedback').val();
            feedback = $.trim(feedback);
            return {
                email: email || null,
                feedback: feedback || null
            }
        },
        sendFeecback: function() {
            var self = this;
            var oAllData = this.getAllVal();
            if (this._isAllValValid(oAllData)) {
                this.showLoading();
                userFeedbackModel.setParam({
                    email: oAllData.email,
                    content: oAllData.feedback
                });
                userFeedbackModel.excute(function(json) {
                    this.hideLoading();
                    this.showToast('反馈成功', {
                        hideAction: function() {
                            self.back();
                        }
                    });
                }, function(msg) {
                    this.hideLoading();
                    if (_.isObject(msg) && msg.message) {
                        this.showToast(msg.message);
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            } else {
                this.showToast(this._errorMsg);
            }
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "意见反馈",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});