define(['BaseView', 'Model', 'Store', 'text!TemplatesGame', 'util'], function(BaseView, models, store, tplGame, util) {

    var isLogin = util.isLogin();
    var bakeGameModel = models.bakeGameModel;
    var userInfoModel = models.userInfoModel;
    var bakeGameStore = store.bakeGameStore;
    var timer;

    if (isLogin) {
        bakeGameModel.url = bakeGameModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    //抄过去代码
    var Games = {
        s: 0, //烤制饼干数量
        m: $(".c_bing span").text() - 0,
        maxRank: 5, //最大等级
        rank: 1 //等级
    };

    var view = BaseView.extend({
        viewName: 'game',
        gameid: null,
        forShareData: {
            title: null,
            content: null
        },
        events: {
            'click .js_toAcvhive': 'toAachieve',
            'click .js_shareFriend': 'toShareFriend',
            'click .cake .cook': 'startGame',
            'click .cake .again': 'startGame',
            'click .x_confirm': 'closeConfirm'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            if (!isLogin) {
                this.jump(['views/login_phone.html', '?from=views/', this.viewName, '.html'].join(''));
                return;
            }
            this.showLoading();
            userInfoModel.setParam({
                access_token: util.getToken()
            });
            userInfoModel.excute(function(json) {
                this.hideLoading();
                Games.rank = parseInt(json.result.level_id);
                this.render(_.template(tplGame)(json.result));
                this.getGameStatus();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        /**
         * 获取烤面粉当前状态，
         * 有JSON说明正在烤，获得其剩余时间，饼干数量，面粉数量
         * 走到msg说明游戏结束，或者没有开始游戏
         */
        getGameStatus: function() {
            this.showLoading();
            bakeGameModel.setParam({
                game: 'cur_game'
            });
            bakeGameModel.excute(function(json) {
                this.hideLoading();
                bakeGameStore.setAttr('points', json.result.prizes.points);
                bakeGameStore.setAttr('flour', json.result.prizes.flour);
                bakeGameStore.setAttr('badgeId', json.result.prizes.badge_id);
                var nLeftTime = parseInt(json.result.time);
                this.doingGame(nLeftTime);
                //分享面粉就是靠这个game_id来分享
                this.gameId = json.result.game_id;
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    if (msg.code != 500) {
                        this.showToast(msg.message);
                    }
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        /**
         * 点击开始烤，获得数据
         * 获取 game_id 为之后的抢面粉做准备
         * @param  {event}
         */
        startGame: function(e) {
            this.showLoading();
            bakeGameModel.setParam({
                game: 'start'
            });
            bakeGameModel.excute(function(json) {
                this.hideLoading();
                var nLeftTime = parseInt(json.result.time);
                this.doingGame(nLeftTime);
                //分享面粉就是靠这个game_id来分享
                this.gameId = json.result.game_id;
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        doingGame: function(nLeftTime) {
            var self = this;
            self.countDown(nLeftTime);
            $(".give,.again").hide();
            $(".xiaoren").removeClass("a_fly").hide();
            $(".c_tips").removeClass("a-show");
            $(".c_row3 p").html('<p>游戏说明：完成一次烘焙需要20分钟，每次的<br>面粉奖励不同，获得面粉越多，等级越高哦~~<a href="javascript:void(0)" class="js_toAcvhive"><span>我的成就></span></a></p>');
            //动画效果
            $(".c_box").animate({
                "left": "30%",
                "top": "30%"
            }, 200).addClass("b-swing");
            $(".c_box").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_boxing.png");

            $(".c_cake_guang").removeClass("a-guang").hide();
            $(".c_cake").animate({
                "left": "33%"
            }, 200).removeClass("a-swing").show();
            $(".c_cake").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_cakeing.png");
            $(".c_yan").show(200);
        },
        endGame: function() {
            this.showLoading();
            bakeGameModel.setParam({
                game: 'end'
            });
            bakeGameModel.excute(function(json) {
                this.hideLoading();
                //动画效果
                $(".xiaoren").show().addClass("a_fly"); /*饼干人飞入*/
                $(".c_box").animate({
                    "left": "55%",
                    "top": "45%"
                }, 200).removeClass("b-swing");
                $(".c_box").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_boxed.png");

                $(".c_cake").animate({
                    "left": "2%"
                }, 200).addClass("a-swing").hide();
                $(".c_yan").hide(100);
                $(".cook").hide();
                $(".c_tips").addClass("a-show");
                $(".give,.again").show();
                //面粉数量计算
                var addPoints = parseInt(bakeGameStore.getAttr('points'));
                var addFlour = parseInt(bakeGameStore.getAttr('flour'));
                var curPoints = parseInt($(".c_bing span").text());
                var curFlour = parseInt($(".c_mian span").text());
                if (addPoints && addFlour) {
                    $(".c_bing span").text(addPoints + curPoints);
                    $(".c_mian span").text(addFlour + curFlour);
                    bakeGameStore.set();
                }
                //等级计算
                // this.Rank();

            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        countDown: function(nLeftTime) {
            var self = this;

            function _countDown() {
                if (nLeftTime >= 0) {
                    minutes = Math.floor(nLeftTime / 60);
                    seconds = Math.floor(nLeftTime % 60);
                    $(".cook").addClass('cooking');
                    $(".cook").find('span').html(['<b id="m">', minutes, '</b>分<b id="s">', seconds, '</b>秒'].join(''));
                    --nLeftTime;
                } else {
                    clearInterval(timer);
                    self.endGame();
                }
            }
            timer = setInterval(function() {
                _countDown();
            }, 1000);
        },
        closeConfirm: function() {
            $(".xunzhang").hide();
        },
        Play: function() {
            // var self = this;
            // $(".cook").click(function() {
            //     $(this).addClass("cooking");
            //     $(".cook").find("span").html('<b id="m">0</b>分<b id="s">5</b>秒');
            //     countTime(); /*时间倒计时*/
            //     $(".c_box").animate({
            //         "left": "30%"
            //     }, 200).addClass("b-swing");
            //     $(".c_box").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_boxing.png");

            //     $(".c_cake_guang").removeClass("a-guang").hide();
            //     $(".c_cake").animate({
            //         "left": "33%"
            //     }, 200).removeClass("a-swing");
            //     $(".c_cake").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_cakeing.png");
            //     $(".c_yan").show(200);
            // });

            /*烤饼干成功-结束*/
            function cooked(GameNum, AddFlourNum, BadgeId) {
                $(".xiaoren").show().addClass("a_fly"); /*饼干人飞入*/
                $(".c_box").animate({
                    "left": "55%",
                    "top": "45%"
                }, 200).removeClass("b-swing");
                $(".c_box").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_boxed.png");

                $(".c_cake").animate({
                    "left": "2%"
                }, 200).addClass("a-swing").hide();
                $(".c_yan").hide(100);
                $(".cook").hide();
                $(".c_tips").addClass("a-show");
                $(".give,.again").show();

                /*面粉数量计算*/
                (function() {
                    var n = $(".c_mian span").text() - 0,
                        m = $(".c_tips b").text() - 0;
                    $(".c_mian span").text(n + m);
                })();

                Games.s++;
                $(".c_bing span").text(Games.m + Games.s);

                self.Rank();
            }

            /*再烤一次*/
            $(".again").click(function() {
                $(".give,.again").hide();
                $(".xiaoren").removeClass("a_fly").hide();
                $(".c_tips").removeClass("a-show");
                $(".c_row3 p").html('游戏说明：烤一次饼干需要20分钟，不同的<br>饼干活动面粉数量不同，得越多，等级越高哦~~<a href="succeed.html"><span>我的成就></span></a>');

                $(".cook").addClass("cooking").show();
                $(".cook").find("span").html('<b id="m">0</b>分<b id="s">5</b>秒');
                countTime(); /*时间倒计时*/

                $(".c_box").animate({
                    "left": "30%",
                    "top": "30%"
                }, 200).addClass("b-swing");
                $(".c_box").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_boxing.png");

                $(".c_cake").animate({
                    "left": "33%"
                }, 200).removeClass("a-swing").show();
                $(".c_cake").find("img").attr("src", Turtle.baseUrl + "/../resource/images/cake/c_cakeing.png");
                $(".c_yan").show(200);

            });

            /*获得勋章提示*/
            $(".x_confirm").click(function() {
                $(".xunzhang").hide();
            });

        },
        Rank: function() {
            var str1 = [],
                str2 = [],
                str3 = [];
            console.log(Games.rank);
            switch (Games.rank) {
                case 1:
                    str1 = ['一盘黄油曲奇', '一盘花生曲奇', '一盘巧克力曲奇', '一盘柠檬曲奇'];
                    str2 = ['3', '5', '7', '4'];
                    str3 = ['x1/x1_1', 'x1/x1_2', 'x1/x1_3', 'x1/x1_4'];
                    break;

                case 2:
                    str1 = ['一盘戚风蛋糕', '一盘提拉米苏', '一盘熔岩蛋糕', '一盘红丝绒蛋糕'];
                    str2 = ['10', '11', '13', '15'];
                    str3 = ['x2/x2_1', 'x2/x2_2', 'x2/x2_3', 'x2/x2_4'];
                    break;

                case 3:
                    str1 = ['一盘黄油面包', '一盘肉松面包', '一盘五谷面包', '一盘牛角面包'];
                    str2 = ['19', '20', '23', '22'];
                    str3 = ['x3/x3_1', 'x3/x3_2', 'x3/x3_3', 'x3/x3_4'];
                    break;

                case 4:
                    str1 = ['一盘黄单层翻糖', '一盘双层翻糖', '一盘三层翻糖', '一盘多层翻糖'];
                    str2 = ['24', '25', '27', '29'];
                    str3 = ['x3/x3_1', 'x3/x3_2', 'x3/x3_3', 'x3/x3_4'];
                    break;

                case 4:
                    str1 = ['一盘香草拿破仑', '一盘蓝莓拿破仑', '一盘草莓拿破仑', '一盘1842拿破仑'];
                    str2 = ['30', '32', '33', '36'];
                    str3 = ['x3/x3_1', 'x3/x3_2', 'x3/x3_3', 'x3/x3_4'];
                    break;

            }

            var num = Math.floor(Math.random() * 4);
            $(".c_tips b").text(str2[num]); /*烤出面粉数量*/
            $(".c_row3 p").html('成功啦！恭喜您获得' + str1[num] + '和' + str2[num] + '袋面粉,送给朋友还可以再获得1袋哦~');
            setTimeout(function() {
                $(".xunzhang").show();
                $(".x_zhang img").attr("src", Turtle.baseUrl + "/../resource/images/cake/xunzhang/" + str3[num] + ".png"); /*获得的勋章*/
            }, 1000);
        },

        toAachieve: function() {
            this.jump(['views/game_achieve.html?from=views/', this.viewName, '.html'].join(''));
        },
        toShareFriend: function() {
			// 测试环境地址
        		// href = http://218.244.146.56/mobile/views/game_reg.html?gameid=
            if (Turtle.isInApp) {
                this.showMask({
                    href: ['http://m.imianfen.com/mobile/views/game_reg.html?gameid=', this.gameId, '&isshare=1'].join(''),
                    title: this.forShareData.title,
                    content: this.forShareData.content,
                    imgUrl: ['http://m.imianfen.com/mobile/unpackage/res/icons/144x144.png'],
                    isSina: true,
                    a1:7,
                    a2:0,
                    a3:util.getToken()
                });
            } else {
                this.jump(['views/game_reg.html?gameid=', this.gameId, '&from=views/', this.viewName, '.html'].join(''));
            }
        },
        showMask: function(opt) {
            var floatw = null,
                extras = opt,
                styles = {
                    'bottom': 0,
                    'width': '100%',
                    'height': '177px',
                    'background': "rgba(0,0,0,0.8)",
                    'scrollIndicator': 'none',
                    'scalable': false,
                    'popGesture': 'none'
                };

            floatw = plus.webview.create('/appviews/mask_layer.html', 'mask_layer.html', styles, extras);
            floatw.addEventListener("loaded", function() {
                floatw.show('fade-in', 300);
                floatw = null;
            }, false);
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon closes",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "面粉实验室",
                    className: "title"
                }],
                rightHandler: [{
                    className: 'icon set',
                    event: function(event) {
                        self.jump(['views/set.html?from=views/', self.viewName, '.html'].join(''));
                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});