define(['BaseView', 'Model', 'Store', 'text!TemplatesGameAchieve', 'util'], function(BaseView, models, store, tplGameAchieve, util) {

    var userInfoModel = models.userInfoModel;

    var view = BaseView.extend({
        viewName: 'game_achieve',
        events: {
            'click .js_toGame': 'toGame'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            
            this.showLoading();
            userInfoModel.setParam({
                access_token: util.getToken()
            });
            userInfoModel.excute(function(json) {
                this.hideLoading();
                //抄原先的代码
                var Games = {
                    maxRank: 5, //最大等级
                    rank: 1 //等级
                };
                Games.rank = parseInt(json.result.level_id);
                this.render(_.template(tplGameAchieve)(json.result));
                this.level(Games);
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        toGame: function() {
            // this.jump(['views/game.html?from=views/', this.viewName, '.html'].join(''));
            this.back();
        },
        level: function(Games) {
            /*等级进度条*/
            switch (Games.rank) {
                case 1:
                    $(".s_barin,.s_barico").animate({
                        "left": "-73%"
                    }, 1000);
                    for (var g = Games.rank; g <= Games.maxRank; g++) {
                        for (var i = 0; i < 4; i++) {
                            $(".s_zlist ul.jz" + g + " li").eq(i).find("span").addClass("lock_" + i);
                        }
                    }
                    break;
                case 2:
                    $(".s_barin,.s_barico").animate({
                        "left": "-54%"
                    }, 1000);
                    for (var g = Games.rank; g <= Games.maxRank; g++) {
                        for (var i = 0; i < 4; i++) {
                            $(".s_zlist ul.jz" + g + " li").eq(i).find("span").addClass("lock_" + i);
                        }
                    }
                    break;
                case 3:
                    $(".s_barin,.s_barico").animate({
                        "left": "-38%"
                    }, 1000);
                    for (var g = Games.rank; g <= Games.maxRank; g++) {
                        for (var i = 0; i < 4; i++) {
                            $(".s_zlist ul.jz" + g + " li").eq(i).find("span").addClass("lock_" + i);
                        }
                    }
                    break;
                case 4:
                    $(".s_barin,.s_barico").animate({
                        "left": "-21%"
                    }, 1000);
                    for (var g = Games.rank; g <= Games.maxRank; g++) {
                        for (var i = 0; i < 4; i++) {
                            $(".s_zlist ul.jz" + g + " li").eq(i).find("span").addClass("lock_" + i);
                        }
                    }
                    break;
                case 5:
                    $(".s_barin,.s_barico").animate({
                        "left": "0%"
                    }, 500);
                    for (var g = Games.rank; g <= Games.maxRank; g++) {
                        for (var i = 0; i < 4; i++) {
                            $(".s_zlist ul.jz" + g + " li").eq(i).find("span").addClass("lock_" + i);
                        }
                    }
                    break;
            }
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "我的成就",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});