define(['BaseView', 'Model', 'Store', 'GameData', 'text!TemplatesGameList'], function(BaseView, models, store, GameData, tplGameList) {

    var getGameTakeModel = models.gameTakeModel;
	var userInfoStore = store.gameUserInfoStore;
	
    var view = BaseView.extend({
        viewName: 'game_list',
        events: {

        },
        render: function(html) {
            this.$el.html(html);
        },
        execAjax: function () {
        		var gameId = Turtle.getQuery('gameid'),
        			phone = Turtle.getQuery('phone');
        			
        		this.showLoading();
        		getGameTakeModel.setParam({
				game_id: gameId,
				mobile: phone
			});
			getGameTakeModel.excute(function(json){
				this.hideLoading();
				var userInfo = userInfoStore.getAttr('userInfo');
				
				this.render(_.template(tplGameList)({'data': json.result, 'userInfo': userInfo, 'getNickName': GameData.getNickName, 'getPortrait': GameData.getPortrait}));
			}, function(msg){
				this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
			}, false, this);
        },
        onShow: function() {
        		this.execAjax();
        }
    });

    this.viewIntance = view.getIntance();
});