define(['BaseView', 'Model', 'Store', 'UIDialog', 'GameData', 'text!TemplatesGameReg'], function(BaseView, models, store, UIDialog, GameData, tplGameReg) {

    var getUserBackModel = models.userBackModel;
    var userInfoStore = store.gameUserInfoStore;
    var gameId = '';

    var view = BaseView.extend({
        viewName: 'game_reg',
        events: {
        		'click #js_robflour': 'toRobFlour',
			'click #js_rule': 'toRule'
        },
        toRobFlour: function() {
        		var reg = /^(1[3-8][0-9])\d{8}$/,
        			phone = $.trim($('#js_phone').val());
        		
        		if(reg.test(phone)) {
        			this.jump('views/game_list.html?gameid=' + gameId + '&phone=' + phone);
        		} else {
				new UIDialog({
                    model: {
                        content: '请输入正确的手机号码'
                    }
                }).show();        			
        		}
        },
        toRule: function() {
        		this.jump('views/game_guize.html');
        },
        render: function(html) {
            this.$el.html(html);
        },
        execAjax: function() {
        	gameId = Turtle.getQuery('gameid');

			this.showLoading();
			getUserBackModel.setParam({
				game_id: gameId
			});
			getUserBackModel.excute(function(json){
				this.hideLoading();
				var result = json.result,
					result = {},
					userInfo = {
						nickname: result.nickname ? result.nickname : GameData.getNickName(),
						head_img_url: result.head_img_url ? result.head_img_url : GameData.getPortrait()
					};
										
				this.render(_.template(tplGameReg)({data: userInfo}));
				userInfoStore.setAttr('userInfo', userInfo);
			}, function(msg){
				this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
			}, false, this);		
        },
        onShow: function() {
        	this.execAjax();
        }
    });

    this.viewIntance = view.getIntance();
});