define(['BaseView', 'Model', 'Store', 'text!TemplatesLoginPhone', 'utilValidate', 'utilEncryption'], function(BaseView, models, store, tplLoginPhone, utilValidate, utilEncryption) {

    var getAccessTokenModel = models.getAccessTokenModel;
    var getConfigModel = models.getConfigModel;
    var headStore = store.headStore;

    var view = BaseView.extend({
        viewName: 'login_phone',
        _errorMsg: null,
        _dateTime: null, //从 sys_datetime 获取用做加密用
        events: {
            'click .js_login': 'login',
            'click .js_to_resetpassword':'toResetpassword',
            'click .js_to_register': 'toRegister'
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.render(_.template(tplLoginPhone)());
            this.getSiteConfig();
        },
        getSiteConfig: function() {
            this.showLoading();
            getConfigModel.setParam({
                client: 1
            });
            getConfigModel.excute(function(json) {
                this.hideLoading();
                //服务器返回的 "2015-06-24 11:08:53" 就用他们原来的代码改了
                var sysDatetime = json.result.sys_datetime;
                var aDateTime = sysDatetime.replace(" ", ":").replace(/\:/g, "-").split("-");
                this._dateTime = aDateTime[1] + aDateTime[2];
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        login: function() {
            var self = this;
            var oAllData = this.getAllVal();
            if (this._isAllValValid(oAllData)) {
                this.showLoading();
                getAccessTokenModel.setParam({
                    channel: "user_channel_mobile",
                    username: oAllData.mobileNum,
                    userpwd: this._makeMD5(oAllData.password, this._dateTime),
                    client_id:  Turtle.isInApp ? plus.push.getClientInfo().clientid : '' //个推用
                });
                getAccessTokenModel.excute(function(json) {
                    this.hideLoading();
                    //登陆就为了获得一个密钥和传入的user手机号
                    var username = oAllData.mobileNum;
                    var secretKey = json.result;
                    headStore.setAttr('username', username);
                    headStore.setAttr('token', secretKey);

                    this.showToast('登录成功', {
                        'hideSec': 1000,
                        'hideAction': function() {
                            self.jump(['views/article.html'].join(''));
                        }
                    });


                }, function(msg) {
                    this.hideLoading();
                    if (_.isObject(msg) && msg.message) {
                        // this.showToast(msg.message);
                         $(".login_info").html(msg.message);
                        return;
                    }
                    this.showToast('网络错误，请稍候重试。');
                }, false, this);
            } else {
                // this.showToast(this._errorMsg);
            }
        },
        _makeMD5: function(password, sDate) {
            return utilEncryption.md5(utilEncryption.md5(password) + sDate);
        },
        _isAllValValid: function(oAllData) {
            if (!utilValidate.isMobile(oAllData.mobileNum)) {
                $(".login_info").html("手机号码格式不正确");
                // this._errorMsg = '手机号码格式不正确';
                return false;
            }
            if (!oAllData.password) {
                $(".login_info").html("请输入密码");
                // this._errorMsg = '请输入密码';
                return false;
            }
            return true;
        },
        getAllVal: function() {
            var mobileNum = this.$el.find('.js_mobile').val();
            mobileNum = parseInt(mobileNum);
            var password = this.$el.find('.js_pwd').val();
            return {
                mobileNum: mobileNum || null,
                password: password || null
            }
        },
        toRegister: function(e) {
            this.jump(['views/register_phone.html?from=views/', this.viewName, '.html'].join(''));
        },
        toResetpassword:function(e){
            this.jump(['views/reset_password.html?from=views/', this.viewName, '.html'].join(''));
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    // className: "icon closes",
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "登录",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});