define(['BaseView', 'Model', 'Store', 'text!TemplatesMap'], function(BaseView, models, store, tplMap) {

    // var getArticleListsModel = models.getArticleListsModel;
    var addressStore = store.addressStore;

    var view = BaseView.extend({
        viewName: 'map',
        events: {

        },
        render: function(html) {
            this.$el.html(html);
        },
        initMap: function() {
            var map = new BMap.Map('map');
            map.addControl(new BMap.ZoomControl());
            // 创建地址解析器实例
            var myGeo = new BMap.Geocoder();
            // 将地址解析结果显示在地图上,并调整地图视野
            myGeo.getPoint(addressStore.getAttr('address'), function(point){
                map.centerAndZoom(point, 16);
                map.addOverlay(new BMap.Marker(point));
            });
        },
        initAppMap: function(){
        		var address = addressStore.getAttr('address');
        		plus.maps.Map.geocode(address, {city:'北京'},function(event){
    			 var map = new plus.maps.Map('map');
    			 var marker = null;
    			 var point = event.coord;  // 转换后的坐标信息
    			 map.centerAndZoom(new plus.maps.Point(point.longitude, point.latitude),18);
    			 marker=new plus.maps.Marker(new plus.maps.Point(point.longitude, point.latitude));
				 marker.setIcon("/resource/images/address.png");
				 map.addOverlay(marker);
        		},function(e){
				alert("Failed:"+JSON.stringify(e));
			});
        },
        onShow: function() {
            this.render(_.template(tplMap)());
            // if (!Turtle.isInApp) {
            		this.initMap();
            // } else {
            // 		this.initAppMap();
            // }
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "地图"
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});