define(['BaseView', 'Model', 'Store', 'text!TemplatesMapShowActivity', 'util', 'UISlide'], function(BaseView, models, store, tplMapShowActivity,  util, UISlide) {
    var isLogin = util.isLogin();
    var getMapMerchantModel = models.getMapMerchantModel;
    var view = BaseView.extend({
        viewName: 'mapshow_activity',
        events: {
            'click .merchantinfo': 'toMerchant'
        },
        render: function(html, parent) {
            this.$el.html(html);
        },
        toMerchant: function(e){
            var zpItem = $(e.currentTarget);
            var pageName = zpItem.data('merchantid');
            var activityid = Turtle.getQuery('activityid');
            param = ['merchantid=', pageName].join('');
            this.back();

            // this.jump(['views/merchantview.html?', 'merchantid=', pageName,'&activityid=',activityid, '&from=views/', this.viewName, '.html'].join(''));
        },
        onShow: function() {
            this.render(_.template(tplMapShowActivity)());
            var x = Turtle.getQuery('posx');
            var y = Turtle.getQuery('posy');
            this.merchantid = Turtle.getQuery('merchantid');

            map = new BMap.Map('js_maplist');
            var point = new BMap.Point(x,y);
            map.centerAndZoom(point, 17);
            map.addControl(new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_RIGHT, type: BMAP_NAVIGATION_CONTROL_ZOOM}));
            var self = this;
             var myIcon = new BMap.Icon(Turtle.baseUrl + "/../resource/images/map_icon_search.png", new BMap.Size(13,19));
            var mk = new BMap.Marker(point,{icon:myIcon});
            map.addOverlay(mk);
            this.getMerchantList();
        },
        getMerchantList:function(){
            var bs = map.getBounds();   //获取可视区域
            var bssw = bs.getSouthWest();   //可视区域左下角
            var bsne = bs.getNorthEast();
            var merchantid = this.merchantid;
            getMapMerchantModel.setParam({
                 ws:bssw.lng,
                 ys:bssw.lat,
                 we:bsne.lng,
                 ye:bsne.lat
            });
            getMapMerchantModel.excute(function(json) {
                for (var i in json.result) {
                    id = json.result[i].id;
                    if(id==merchantid){
                        point = new BMap.Point();
                        eval(" mapmarker"+id+" = new BMap.Marker(point);");
                        eval(" map.addOverlay(mapmarker"+id+");");
                        flag = '';
                        if(json.result[i].type1 ==1 ){
                            flag +='<span class="span1">　</span>';
                        }
                        if(json.result[i].type2 ==1 ){
                            flag +='<span class="span2">　</span>';
                        }
                        if(json.result[i].type3 ==1 ){
                            flag +='<span class="span3">　</span>';
                        }
                        $("#main").append('<div class="merchantinfo" id="merchantinfo'+json.result[i].id+'" data-merchantid="'+json.result[i].id+'"><div class="sta">'+ flag +'</div><img class="logo" src="'+json.result[i].logoimage+'"><div class="name">'+json.result[i].name+'</div><div class="address">'+json.result[i].address+'</div><img class="ico_tp" src="'+Turtle.baseUrl+'/../resource/images/btn_right.png"></div>');
                         $("#merchantinfo"+json.result[i].id).show();
                    }
                }
            }, function(msg) {
                this.hideLoading();

                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },

        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.back();
                    }
                }],
                centerHandler: [{
                    title: "地图",
                    className: "title"
                }],
                rightHandler: [{
                    value: '',
                    className: "",
                    event: function(event) {
                        self.jump(['views/activity.html'].join(''));
                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});