define(['BaseView', 'Model','text!TemplatesMask_layer', ], function(BaseView,models, tplMaskLayer) {
	var currentWebview = null,
		shares = null,
		opt = null;
    var baseshare = models.baseshare;

	var view = BaseView.extend({
		events: {
			'click #js_ec-popover-cancel': 'removeMask',
			'click .ec-share-warp li': 'shareIt'
		},
		shareIt: function(e){
			var $el = $(e.currentTarget),
				shareType = $el.data('share-type'),
				index = $el.index();

			switch(index) {
				case 0:
				case 1:
					this.shareAction('weixin', shareType);
					break;
				case 2:
					this.shareAction(shareType);
					break;
			}

		},
		updateSerivces: function() {
			plus.share.getServices(function(s) {
				shares = {};
				for (var i in s) {
					var t = s[i];
					shares[t.id] = t;
				}
			}, function(e) {
				//outSet( "获取分享服务列表失败："+e.message );
			});
		},
		shareAction: function(id, ex) {
			var s = null,
				self = this;

			if (!id || !(s = shares[id])) {
				return;
			}
			if (s.authenticated) {
				self.shareMessage(s, ex);
			} else {
				s.authorize(function() {
					self.shareMessage(s, ex);

				}, function(e) {
					// alert(e.message);
				});
			}
		},
		shareMessage: function(s, ex) {
			var msg = {
					href: opt.href,
					title: opt.title,
					content: opt.content,
					thumbs: opt.imgUrl,
					extra: {
						scene: ex
					}
				},
				self = this;

			s.send(msg, function() {
				baseshare.setParam({
	                access_token: opt.a3,
	                share_id:  opt.a2,
	                action: opt.a1
	            });
	            baseshare.excute(function(json) {
	            	alert( "分享到\""+s.description+"\"成功！ " );
					self.removeMask();
	            }, function(msg) {
	            	alert( "分享到\""+s.description+"\"成功！ " );
					self.removeMask();
	            }, false, this);
			}, function(e) {
				if(e.message.indexOf('20019')>-1){
					alert('分享过于频繁！请稍后再试');
				}
				self.removeMask();

			});
		},

		removeMask: function(event) {
			$('#js_share').removeClass('ec-active');
			setTimeout(function() {
				currentWebview.hide('fade-out');
			}, 30);
		},
		share: function() {
			var self = this;

			setTimeout(function() {
				$('#js_share').addClass('ec-active');
				self.updateSerivces();
			}, 10);
		},
		render: function(html) {
			this.$el.html(html);
		},
		onShow: function() {
			currentWebview = plus.webview.currentWebview();
			opt = {
					href: currentWebview.href,
					title: currentWebview.title,
					content: currentWebview.content,
					imgUrl: currentWebview.imgUrl,
					a1:currentWebview.a1,
					a2:currentWebview.a2,
					a3:currentWebview.a3
			};

			var isSina = currentWebview.isSina;
			this.render(_.template(tplMaskLayer)({'isSina': isSina}));
			this.share();
		}
	});

	this.viewIntance = view.getIntance();
});