define(['BaseView', 'Model', 'Store', 'text!TemplatesMerchantview', 'text!TemplatesMerchantviewLoadingMore', 'util', 'UISlide',  'Swiper', 'iScroll'], function(BaseView, models, store, tplArticleview, tplActivityLoadingMore,  util, UISlide, Swiper) {
    var isLogin = util.isLogin();
    var getMerchantDetailModel = models.getMerchantDetailModel;
    var myScroll;
    var view = BaseView.extend({
        viewName: 'merchantview',
        merchantid: null,
        _curPage: 0,
        _totalPage: 1,
        forShareData: {
            name: null,
            description: null
        },
        events: {
            'click .js_activityItem': 'toActivityDetail',
            'click .js_toMap': 'toMap'
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },
        onShow: function() {
            this.merchantid = Turtle.getQuery('merchantid');
            this.activityid = Turtle.getQuery('activityid');
            this.showLoading();
            getMerchantDetailModel.setParam({
                access_token: util.getToken(),
                pageSize: 10,
                curPage: 0,
                merchantid: this.merchantid
            });
            getMerchantDetailModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplArticleview)(json.result));
                this.forShareData.name = json.result.name;
                this.forShareData.description = json.result.description;
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.initScroll();
                this.initSwiper(json.result);
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;

            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage >= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }

            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage < self._totalPage) {
                            getMerchantDetailModel.setParam({
                                access_token: util.getToken(),
                                pageSize: 10,
                                curPage: self._curPage,
                                merchantid: self.merchantid
                            });
                            getMerchantDetailModel.excute(function(json) {
                                self.render(_.template(tplActivityLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                if (self._curPage == self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中...';
                            pullUpAction();
                        }
                    }
                });
                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);
            }
            loaded();
        },
        initSwiper: function(data) {
            var self = this;
            var swiperImg = new Swiper('.swiper-container', {
                nextButton: '.swiper-button-next',
                prevButton: '.swiper-button-prev',
                lazyLoading: true,
                onInit: function(swiper) {
                    self.$el.find('.page_act').text(swiper.activeIndex + 1);
                    self.$el.find('.page_sum').text(swiper.slides.length);
                },
                onSlideChangeEnd: function(swiper) {
                    self.$el.find('.page_act').text(swiper.activeIndex + 1);
                }
            });
        },
        toMap:function(e){
            var from = encodeURIComponent('views/merchantview.html?merchantid=' + this.getQuery('merchantid'));
            var zpItem = $(e.currentTarget);
            var posx = zpItem.data('posx');
            var posy = zpItem.data('posy');
            this.jump('views/mapshow_activity.html?posx='+posx+'&posy='+posy+'&merchantid='+this.merchantid+'&from=' + from);
            // this.jump('views/mapshow.html?posx='+posx+'&posy='+posy+'&from=' + from);
        },
        toActivityDetail: function(e) {
            var zpItem = $(e.currentTarget);
            var activityid = zpItem.data('activityid');
            var param = ['activityid=', activityid].join('');
            this.jump(['views/activityview.html?', param, '&from=views/', this.viewName, '.html','?merchantid=', this.getQuery('merchantid')].join(''));
        },
        showMask: function(opt) {
            var floatw = null,
                extras = opt,
                styles = {
                    'bottom': 0,
                    'width': '100%',
                    'height': '177px',
                    'background': "rgba(0,0,0,0.8)",
                    'scrollIndicator': 'none',
                    'scalable': false,
                    'popGesture': 'none'
                };

            floatw = plus.webview.create('/appviews/mask_layer.html', 'mask_layer.html', styles, extras);
            floatw.addEventListener("loaded", function() {
                floatw.show('fade-in', 300);
                floatw = null;
            }, false);
        },
        updateHeader: function() {
            var self = this;

            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        var fromUrl = self._fromUrlStore.getAttr(self.viewName);

                        if (Turtle.isInApp) {
                            if (Turtle.getQuery('activityid')) {
                                self.jump(['views/activityview.html?activityid='+Turtle.getQuery('activityid')+'&merchantid='+Turtle.getQuery('merchantid')+'&from=views/activity.html'].join(''));
                                return;
                            }
                            mui.back(); // 目前采用直接回退
                        } else {
                            if (fromUrl) {
                                //微信分享外链直接跳进来
                                if (Turtle.getQuery('isshare')) {
                                    self.jump(['views/article.html'].join(''));
                                    return;
                                }
                                if (Turtle.getQuery('activityid')) {
                                    self.jump(['views/activityview.html?activityid='+Turtle.getQuery('activityid')+'&from=views/activity.html'].join(''));
                                    return;
                                }
                                self.jump(fromUrl)
                            } else {
                                self.jump(Turtle.homeUrl);
                            }
                        }
                    }
                }],
                centerHandler: [{
                    title: "商家详情",
                    className: "title"
                }],
                rightHandler: [{
                    className: Turtle.isInApp ? "icon sharer2" : '',
                    event: function(event) {
                        self.showMask({
                            href: ['http://m.imianfen.com/mobile/views/merchantview.html?merchantid=', self.merchantid, '&isshare=1'].join(''),
                            title: self.forShareData.name,
                            content: self.forShareData.description,
                            imgUrl: ['http://m.imianfen.com/mobile/unpackage/res/icons/144x144.png'],
                            a1:13,
                            a2:self.merchantid,
                            a3:util.getToken()
                        });
                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});