define(['BaseView', 'Model', 'Store', 'UIDialog', 'text!TemplatesMyaa', 'text!TemplatesMyaaLoadingMore', 'util', 'iScroll'], function(BaseView, models, store, UIDialog, tplActivity, tplActivityLoadingMore, util) {

    var isLogin = util.isLogin();
    var getActivityCommentListModel = models.getActivityMyaaModel;
    // var sendActivityCommentModel = models.sendActivityCommentModel;

    var userInfoModel = models.userInfoModel;
    var myScroll;

    var view = BaseView.extend({
        viewName: 'myaa',
        _curPage: 0,
        _totalPage: 1,
        events: {
            'click .js_toActivity': 'toActivity',
        },
        toActivity:function(e){
            var zpItem = $(e.currentTarget);
            var activityid = zpItem.data('activityid');
            var param = ['activityid=', activityid].join('');
            this.jump(['views/activityview.html?', param, '&from=views/', this.viewName, '.html'].join(''));
        },
        render: function(html, parent) {
            if (parent) {
                parent.append(html);
                return;
            }
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            getActivityCommentListModel.setParam({
                access_token: util.getToken(),
                pageSize: 10,
                curPage: 0
            });
            getActivityCommentListModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplActivity)(json.result));
                this._curPage = json.result.curPage;
                this._totalPage = json.result.totalPage;
                this.initScroll();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        initScroll: function() {
            var self = this;
            var $elWrapper = $('#wrapper');
            var loadStatus = true; //只有每当ajax发送加载完成后才能继续发送ajax
            var isAllLoaded = false; //全部页数都加载完成不用继续加载
            var pullUpEl;
            var pullUpOffset;

            if (myScroll) {
                myScroll.destroy();
            }
            //当前只有一页的情况立刻关闭iscroll
            if (self._curPage <= self._totalPage) {
                $elWrapper.css({
                    'overflow': 'initial'
                });
                return;
            }

            function pullUpAction() {
                if (loadStatus) {
                    loadStatus = false;
                    setTimeout(function() {
                        // ajax
                        if (self._curPage > self._totalPage) {
                            getActivityCommentListModel.setParam({
                                pageSize: 10,
                                curPage: self._curPage,
                            });
                            getActivityCommentListModel.excute(function(json) {
                                self.render(_.template(tplActivityLoadingMore)(json.result), self.$el.find('.js_list'));
                                self._curPage = json.result.curPage;
                                self._totalPage = json.result.totalPage;
                                if (self._curPage == self._totalPage) {
                                    isAllLoaded = true;
                                    self.$el.find('.art_none').removeClass('none');
                                }
                                loadStatus = true;
                                myScroll.refresh();
                            }, function(msg) {
                                console.log('error');
                            }, false, self);
                        }
                    }, 1000);
                }
            }

            function loaded() {
                pullUpEl = document.getElementById('pullUp');
                pullUpOffset = pullUpEl.offsetHeight;

                myScroll = new iScroll('wrapper', {
                    useTransition: true,
                    onRefresh: function() {
                        if (pullUpEl.className.match('_loading')) {
                            pullUpEl.className = '';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                        }
                    },
                    onScrollMove: function() {
                        if (this.y < (this.maxScrollY - 5) && !pullUpEl.className.match('flip') && loadStatus) {
                            pullUpEl.className = 'flip';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '';
                            this.maxScrollY = this.maxScrollY;
                        }
                    },
                    onScrollEnd: function() {
                        if (pullUpEl.className.match('flip') && loadStatus && !isAllLoaded) {
                            pullUpEl.className = '_loading';
                            pullUpEl.querySelector('.pullUpLabel').innerHTML = '加载中';
                            pullUpAction();
                        }
                    }
                });
                setTimeout(function() {
                    document.getElementById('wrapper').style.left = '0';
                }, 800);
            }
            loaded();
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/set.html'].join(''));
                        // self.jump(['views/game.html?from=views/', self.viewName, '.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: '我的专享',
                    className: "title"
                }],
                rightHandler: [{
                    value: '',
                    className: "",
                    event: function(event) {

                    }
                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});