define(['BaseView','Model', 'Store', 'Storage','UIDialog', 'text!TemplatesRecipe','util','UISlide','Swiper'], function(BaseView,models, store, Storage, UIDialog, tplRecipe,util,UISlide,Swiper) {
    var tabIndex = 0;
    var headStore = store.headStore;
    var testData = new Array();
    var backimageurl = new Array(new Array());
    var swipers;
    var getRecipesIndexModel = models.getRecipesIndexModel;
    var view = BaseView.extend({
        viewName: "recipe",
        events: {
            'click .recipe_uparrow': 'recipeListShow',
            'click .recipe_bottomarrow': 'backRecipe',
            'click .recipe_title': 'recipeTitleTab',
            'click .swiper-slide': 'toRecipeview',
            'click .js_toBack':'toBack',
            'click .js_setCookie':'setCookie',
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.typeid = Turtle.getQuery('typeid');
            this.articleid = Turtle.getQuery('articleid');
            getRecipesIndexModel.setParam({
                access_token:util.getToken(),
                typeid: this.typeid,
                articleid: this.articleid,
                preview: this.previousid ? this.previousid  : null
            });
            getRecipesIndexModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplRecipe)(json.result));
                var num=$(".recipe_title_on").index();
                tabIndex = num;
                this.typeid = json.result.typeid;
                this.nextRecipeId = json.result.nextid;
                testData = json.result.recipeslist;
                backimageurl = json.result.typelist;
                // this.forShareData.content = json.result.content;
                this.cookieRecipeLayer();
                this.initSwiper(json.result);
                this.screenOrientationEvent();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },

        // 转屏事件，内部功能可以自定义
        screenOrientationEvent:function(){
             var self = this;
            $(window).resize(function(){
                var screen_width=$(window).width();
                var screen_height=$(window).height();
                if(screen_width>screen_height){
                    self.$el.find('.recipe_list').css('display','block');
                    self.$el.find('.recipe_uparrow').css('display','none');
                    self.$el.find('.recipe_bottomarrow').css('display','block');
                }

            });
        },
        setCookie:function (){
            var self = this;
            if(Turtle.isInApp){
                 window.localStorage.setItem("recipecookie", 1);
                self.$el.find('.recipe_layer').css('display','none');
            }else{
                var Days = 30;
                var exp = new Date();
                exp.setTime(exp.getTime() + Days*24*60*60*1000);
                document.cookie = "recipecookie="+ escape (1) + ";expires=" + exp.toGMTString();
                self.$el.find('.recipe_layer').css('display','none');
            }

        },
        cookieRecipeLayer:function(){
            var self = this;
            if(Turtle.isInApp){
                var recipecookie = window.localStorage.getItem("recipecookie");
                if(recipecookie==1){
                    self.$el.find('.recipe_layer').css('display','none');
                }
            }else{
                var arr,reg=new RegExp("(^| )recipecookie=([^;]*)(;|$)");
                if(arr=document.cookie.match(reg)){
                    if(unescape(arr[2])){
                        self.$el.find('.recipe_layer').css('display','none');
                    }
                }
            }

        },
        recipeListShow: function() {
            var self = this;
            self.$el.find('.recipe_list').css('display','block');
            self.$el.find('.recipe_uparrow').css('display','none');
            self.$el.find('.recipe_bottomarrow').css('display','block');
        },
        backRecipe:function(){
            var self = this;
            self.$el.find('.recipe_list').css('display','none');
            self.$el.find('.recipe_uparrow').css('display','block');
            self.$el.find('.recipe_bottomarrow').css('display','none');
        },
        toBack:function(){
            // var self = this;
            // var fromUrl = self._fromUrlStore.getAttr(self.viewName);
            // if (Turtle.isInApp) {
            //     mui.back(); // 目前采用直接回退
            // } else {
            //     if (fromUrl) {
            //         //微信分享外链直接跳进来
            //         if (Turtle.getQuery('articleid')) {
            //             self.jump(['views/article.html?from=views/', this.viewName, '.html'].join(''));
            //             // self.jump(['views/articleview.html?articleid=',this.articleid, '&from=views/', this.viewName, '.html'].join(''));
            //             return;
            //         }
            //         self.jump(fromUrl)
            //     } else {
            //         self.jump(Turtle.homeUrl);
            //     }
            // }
            this.jump(['views/article.html?from=views/', this.viewName, '.html'].join(''));
        },
        toRecipeview:function(e){
            var zpItem = $(e.currentTarget);
            var recipesid = zpItem.data('recipesid');
            var param = ['recipesid=', recipesid].join('');

            if (Turtle.isInApp) {
                var ws = plus.webview.getWebviewById('views/recipeview.html');
                plus.webview.close(ws);
            }
            this.jump(['views/recipeview.html?',param ,'&from=views/', this.viewName, '.html'].join(''));

        },
        //点击切换滑动内容
        recipeTitleTab:function(e){
            var self = this;
            var zpItem = $(e.currentTarget);
            tabIndex = zpItem.index();
            tabIndex =Number(tabIndex);
            zpItem.addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
            var typeid = zpItem.data('typeid');

            var recipeslist="";
            if(testData[typeid]){
                $.each(testData[typeid],function(i,n){
                    recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                });
                if(backimageurl[tabIndex]['backimageurl']!=""){
                    self.$el.find('.recipe').css({'background-image':"url("+backimageurl[tabIndex]['backimageurl']+")",'background-repeat':'no-repeat','background-size':'cover','background-position':'center'});
                }
                recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                swipers.removeAllSlides();
                swipers.prependSlide(recipeslist);
                swipers.onResize();
                swipers.slideTo(0, 1000, false);
            }else{
                swipers.removeAllSlides();
                swipers.onResize();
                swipers.slideTo(0, 1000, false);
            }
        },


        initSwiper: function(data) {
            var self = this;
            var holdPosition = 0;
            var swiper = new Swiper('.swiper-container', {
                slidesPerView: 'auto',
                freeMode: true,
                freeModeMomentumBounce:false,
                freeModeMomentum:false,
                observer:true,//修改swiper自己或子元素时，自动初始化swiper
                observeParents:true,//修改swiper的父元素时，自动初始化swiper
                onTouchStart: function() {
                    this.holdPosition = 0;
                },

                onReachEnd: function(swiper){
                    this.holdPosition = 1;
                },
                // onReachBeginning: function(swiper){
                //     this.holdPosition = 2;
                // },
                onTouchEnd: function(swiper){
                    if(swiper.translate>0){
                        tabIndex=Number(tabIndex-1);

                        if(tabIndex<0){
                            var test=1;
                            tabIndex=0;
                        }
                        self.$el.find('.recipe_title').eq(tabIndex).addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
                        if(test!=1){
                            var typename=self.$el.find('.recipe_title_on').text();
                            $(".recipe_typename").html(typename);
                            $(".recipe_typename").show();
                        }
                        test =0;
                        setTimeout("$('.recipe_typename').hide('slow')",500);
                        var typeid=self.$el.find('.recipe_title_on').data('typeid');
                        var recipeslist="";
                         if(testData[typeid]){
                            $.each(testData[typeid],function(i,n){
                                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                            });
                            if(backimageurl[tabIndex]['backimageurl']!=""){
                                self.$el.find('.recipe').css({'background-image':"url("+backimageurl[tabIndex]['backimageurl']+")",'background-repeat':'no-repeat','background-size':'cover','background-position':'center'});
                            }
                            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                            swiper.removeAllSlides();
                            swiper.prependSlide(recipeslist);
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }else{
                            swiper.removeAllSlides();
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }
                    }

                    if(this.holdPosition==1 && swiper.translate<0){
                        tabIndex=Number(tabIndex+1);
                        var max = 0;
                        max=self.$el.find('.recipe_title').size()-1;
                        if(tabIndex>max){
                            var test =1;
                            tabIndex=tabIndex-1;
                        }

                        self.$el.find('.recipe_title').eq(tabIndex).addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
                        var typename=self.$el.find('.recipe_title_on').text();
                        if(test!=1){
                            $(".recipe_typename").html(typename);
                            $(".recipe_typename").show();
                        }
                        test =0;
                        setTimeout("$('.recipe_typename').hide('slow')",500);
                        var typeid=self.$el.find('.recipe_title_on').data('typeid');
                        var recipeslist="";
                        if(testData[typeid]){
                            $.each(testData[typeid],function(i,n){
                                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                            });
                            if(backimageurl[tabIndex]['backimageurl']!=""){
                                self.$el.find('.recipe').css({'background-image':"url("+backimageurl[tabIndex]['backimageurl']+")",'background-repeat':'no-repeat','background-size':'cover','background-position':'center'});
                            }
                            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                            swiper.removeAllSlides();
                            swiper.prependSlide(recipeslist);
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }else{
                            swiper.removeAllSlides();
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }

                    }
                }
            });
            var recipeslist="";
            $.each(testData[this.typeid],function(i,n){
                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img style='height:102px' src='"+n.backimageurl+"'></div>";
            })
            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
            swiper.prependSlide(recipeslist);
            //供点击事件调用。
            swipers = swiper;
        },
    });
    this.viewIntance = view.getIntance();
})