define(['BaseView', 'Model', 'Store', 'UIDialog','text!TemplatesRecipeStep','util','UISlide','Swiper'], function(BaseView,models, store, UIDialog,tplRecipeStep,util,UISlide,Swiper) {

    var startPos = {x:0,y:0};
    var endPos={x:0,y:0};
    var getRecipesStepModel = models.getRecipesStepModel;
    var previousid = 0;
    var nextid = 0;
    var headStore = store.headStore;
    var view = BaseView.extend({
        viewName: "recipe_step",
        events: {
            'touchstart .recipe': 'start',
            'touchmove .recipe': 'moving',
            'touchend .recipe': 'end',
            'click .js_toBack':'toBack',
            'click .js_toDish':'toDish',
            'click .recipestep_layer':'setCookie',
            'click .recipe_step_time':'toRecipeTime',
            'touchstart .recipestep_layer': 'setCookie',
        },
        toDish:function(){
            this.jump(['views/recipe_dish.html?recipesid=',this.recipesid,'&stepid=',this.stepid,'&'].join(''));
        },
        toBack:function(){
            this.jump(['views/recipeview.html?recipesid=',this.recipesid,'&'].join(''));
        },
        render: function(html) {//recipeview
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.recipesid = Turtle.getQuery('recipesid');
            this.stepid = Turtle.getQuery('stepid');

            getRecipesStepModel.setParam({
                access_token: util.getToken(),
                recipesid: this.recipesid,
                stepid: this.stepid
            });
            getRecipesStepModel.excute(function(json) {
                this.hideLoading();
                this.previousid = json.result.previousid;
                this.nextid = json.result.nextid;
                this.optime = json.result.stepinfo.optime;
                this.stepid = json.result.stepinfo.id;
                this.render(_.template(tplRecipeStep)(json.result));
                 this.cookieRecipeLayer();
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
            // this.render(_.template(tplRecipeStep)()); //如上有ajax返回就是 json.result
        },
        setCookie:function (){
            var self = this;
            window.localStorage.setItem("recipestep", '1');
            self.$el.find('.recipestep_layer').css('display','none');
        },
        cookieRecipeLayer:function(){
            var self = this;
            var recipestepcookie = window.localStorage.getItem("recipestep");
            if(recipestepcookie=='1'){
                this.$el.find('.recipestep_layer').css('display','none');
            }
        },
        start:function(event){
            var touch = event.targetTouches[0]; //touches数组对象获得屏幕上所有的touch，取第一个touch
        　　startPos = {x:touch.pageX,y:touch.pageY,time:+new Date}; //取第一个touch的坐标值
        　　isScrolling = 0; //这个参数判断是垂直滚动还是水平滚动

        },
        moving:function(event){
            if(event.targetTouches.length > 1 || event.scale && event.scale !== 1) return;
            var touch = event.targetTouches[0];
            endPos = {x:touch.pageX - startPos.x,y:touch.pageY - startPos.y};
            isScrolling = Math.abs(endPos.x) < Math.abs(endPos.y) ? 1:0;    //isScrolling为1时，表示纵向滑动，0为横向滑动
            if(isScrolling === 0){
                event.preventDefault();      //阻止触摸事件的默认行为，即阻止滚屏
            }
        },
        end:function(event){
            if(endPos.x > 40 && this.previousid > 0){
                //上一页
                 this.jump(['views/recipe_stepa.html?recipesid=',this.recipesid,'&stepid=',this.previousid,'&from=views/', this.viewName, '.html'].join(''));
            }else if(endPos.x < -40  && this.nextid > 0){
                //下一页
                this.jump(['views/recipe_stepa.html?recipesid=',this.recipesid,'&stepid=',this.nextid,'&from=views/', this.viewName, '.html'].join(''));
            }
            startPos = {x:0,y:0};
            endPos={x:0,y:0};
        },
        toRecipeTime:function(){
            this.jump(['views/recipe_time.html?recipesid=',this.recipesid,'&stepid=',this.stepid,'&optime=',this.optime,'&'].join(''));
        }

    });
    this.viewIntance = view.getIntance();
})