define(['BaseView', 'Model', 'Store', 'UIDialog','text!TemplatesRecipeTime','util','UISlide'], function(BaseView,models, store, UIDialog,tplRecipeTime,util,UISlide) {
    var timeRun = 0;
    var clickTime = 0;
    var audio = document.createElement("audio");
    var getRecipesStepModel = models.getRecipesStepModel;
    var view = BaseView.extend({
        viewName: "recipe_time",
        events: {
            'click .js_toBack':'toBack',
            'click .js_start':'startTime',
            'click .js_retime':'reTime',
        },

        toBack:function(){
            clickTime = 0;
            audio.pause();
            clearInterval(timeRun);
            this.jump(['views/recipe_step.html?recipesid=',this.recipesid,'&stepid=',this.stepid,'&'].join(''));
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.recipesid = Turtle.getQuery('recipesid');
            this.stepid = Turtle.getQuery('stepid');
            this.optime = Turtle.getQuery('optime');
            getRecipesStepModel.setParam({
                access_token: util.getToken(),
                recipesid: this.recipesid,
                stepid: this.stepid
            });
            getRecipesStepModel.excute(function(json) {
                this.hideLoading();
                this.render(_.template(tplRecipeTime)(json.result));
                formatSeconds(this.optime);
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },
        startTime:function(){
            var optime = this.optime;
            if(clickTime==0){
                timeRun = setInterval(function(){
                    optime--;
                    formatSeconds(optime);
                    if(optime==0){
                        clearInterval(timeRun);
                        clickTime=0;
                        if (Turtle.isInApp) {
                            plus.device.vibrate( 2000 );
                            plus.device.beep( 3 );
                        }else{
                            audio.src = "http://zjdx1.sc.chinaz.com/Files/DownLoad/sound1/201507/6175.mp3";
                            audio.play();
                        }
                    }
                },1000);
            }
            clickTime++;
        },
        reTime:function(){
            clickTime = 0;
            audio.pause();
            clearInterval(timeRun);
            formatSeconds(this.optime);
        },
        closeApp: function() {
            if (Turtle.isInApp) {
                mui.plusReady(function() {
                    // 返回键处理
                    plus.key.addEventListener('backbutton', function() {
                        clickTime = 0;
                        audio.pause();
                        clearInterval(timeRun);
                        this.jump(['views/recipe_step.html?recipesid=',this.recipesid,'&stepid=',this.stepid,'&'].join(''));
                    }, false);
                });
            }
        },

    });
    this.viewIntance = view.getIntance();
    function formatSeconds(value) {
        var theTime = parseInt(value);
        var theTime1 = 0;
        if(theTime > 60) {
            theTime1 = parseInt(theTime/60);
            if(theTime1<10){
                theTime1 = "0"+theTime1;
            }
            theTime = parseInt(theTime%60);
            if(theTime<10){
                result = theTime1+":"+"0"+theTime;
            }else{
                result = theTime1+":"+theTime;
            }
        }else{
            if(theTime<10){
                result = "00:0"+theTime;
            }else{
                result = "00:"+theTime;
            }
        }
        $(".recipe_time_optime").html(result);
    }
})