define(['BaseView','Model', 'Store', 'UIDialog', 'text!TemplatesRecipeviewa','util','UISlide','Swiper'], function(BaseView,models, store, UIDialog, tplRecipeviewa,util,UISlide,Swiper) {
    var tabIndex = 0;
    var testData = new Array();
    var swipers;
    var getRecipesIndexModel = models.getRecipesIndexModel;
    var view = BaseView.extend({
        viewName: "recipeview",
         events: {
            'click .recipe_uparrow': 'recipeListShow',
            'click .recipe_bottomarrow': 'backRecipe',
            'click .recipe_title': 'recipeTitleTab',
            'touchstart .recipe': 'start',
            'touchmove .recipe': 'moving',
            'touchend .recipe': 'end',
            'click .js_toBack':'toBack',
            'click .js_toStep':'toStep',
            'click .js_toDish':'toDish',
            'click .swiper-slide': 'toRecipeview',
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            this.showLoading();
            this.recipesid = Turtle.getQuery('recipesid');

            getRecipesIndexModel.setParam({
                recipesid: this.recipesid,
                typeid: this.typeid,
                // previousid: this.previousid ? this.previousid  : 0
            });
            getRecipesIndexModel.excute(function(json) {
                this.hideLoading();
                var num=$(".recipe_title_on").index();
                tabIndex = num;
                this.typeid = json.result.typeid;
                this.nextid = json.result.nextid;
                this.previousid = json.result.previousid;
                this.render(_.template(tplRecipeviewa)(json.result));
                testData = json.result.recipeslist;
                this.screenOrientationEvent();
                // this.forShareData.content = json.result.content;
                this.initSwiper(json.result);
            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);
        },

         // 转屏事件，内部功能可以自定义
        screenOrientationEvent:function(){
             var self = this;
            $(window).resize(function(){
                var screen_width=$(window).width();
                var screen_height=$(window).height();
                if(screen_width>screen_height){
                    self.$el.find('.recipe_list').css('display','block');
                    self.$el.find('.recipe_uparrow').css('display','none');
                    self.$el.find('.recipe_bottomarrow').css('display','block');
                }

            });
        },
        recipeListShow: function() {
            var self = this;
            self.$el.find('.recipe_list').css('display','block');
            self.$el.find('.recipe_uparrow').css('display','none');
            self.$el.find('.recipe_bottomarrow').css('display','block');
        },
        backRecipe:function(){
            var self = this;
            self.$el.find('.recipe_list').css('display','none');
            self.$el.find('.recipe_uparrow').css('display','block');
            self.$el.find('.recipe_bottomarrow').css('display','none');
        },
        toBack:function(){
            this.jump(['views/recipe.html?typeid=',this.typeid,'&from=views/', this.viewName, '.html'].join(''));
        },
        toStep:function(){
            this.jump(['views/recipe_step.html?recipesid=',this.recipesid,'&from=views/', this.viewName, '.html'].join(''));
        },
        toDish:function(){
            this.jump(['views/recipe_dish.html?recipesid=',this.recipesid,'&from=views/', this.viewName, '.html'].join(''));
        },
        toRecipeview:function(e){
            var zpItem = $(e.currentTarget);
            var recipesid = zpItem.data('recipesid');
            var param = ['recipesid=', recipesid].join('');

            this.jump(['views/recipeview.html?',param ,'&from=views/', this.viewName, '.html'].join(''));

        },
        start:function(event){
            var touch = event.targetTouches[0]; //touches数组对象获得屏幕上所有的touch，取第一个touch
        　　startPos = {x:touch.pageX,y:touch.pageY,time:+new Date}; //取第一个touch的坐标值
            endPos={x:0,y:0};
        　　isScrolling = 0; //这个参数判断是垂直滚动还是水平滚动

        },
        moving:function(event){
            if(event.targetTouches.length > 1 || event.scale && event.scale !== 1) return;
            var touch = event.targetTouches[0];
            endPos = {x:touch.pageX - startPos.x,y:touch.pageY - startPos.y};
            isScrolling = Math.abs(endPos.x) < Math.abs(endPos.y) ? 1:0;    //isScrolling为1时，表示纵向滑动，0为横向滑动
            if(isScrolling === 0){
                event.preventDefault();      //阻止触摸事件的默认行为，即阻止滚屏
            }
        },
        end:function(event){
            // if (Turtle.isInApp) {
            //     var ws = plus.webview.getWebviewById('views/recipeview.html');
            //     plus.webview.close(ws);
            // }
            if(endPos.x > 40 && this.previousid > 0){
                //上一页
                 this.jump(['views/recipeview.html?recipesid=',this.previousid,'&from=views/', this.viewName, '.html'].join(''));
            }else if(endPos.x < -40  && this.nextid > 0){
                //下一页
                this.jump(['views/recipeview.html?recipesid=',this.nextid,'&from=views/', this.viewName, '.html'].join(''));
            }
            startPos = {x:0,y:0};
            endPos={x:0,y:0};
        },
        //点击切换滑动内容
        recipeTitleTab:function(e){
            var self = this;
            var zpItem = $(e.currentTarget);
            tabIndex = zpItem.index();
            tabIndex =Number(tabIndex);
            zpItem.addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
            var typeid = zpItem.data('typeid');
            var recipeslist="";
            if(testData[typeid]){
                $.each(testData[typeid],function(i,n){
                    recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                });
                recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                swipers.removeAllSlides();
                swipers.prependSlide(recipeslist);
                swipers.onResize();
                swipers.slideTo(0, 1000, false);
            }else{
                swipers.removeAllSlides();
                swipers.onResize();
                swipers.slideTo(0, 1000, false);
            }
        },


        initSwiper: function(data) {
            var self = this;
            var holdPosition = 0;
            var swiper = new Swiper('.swiper-container', {
                slidesPerView: 'auto',
                freeMode: true,
                freeModeMomentumBounce:false,
                freeModeMomentum:false,
                observer:true,//修改swiper自己或子元素时，自动初始化swiper
                observeParents:true,//修改swiper的父元素时，自动初始化swiper
                onTouchStart: function() {
                    this.holdPosition = 0;
                },

                onReachEnd: function(swiper){
                    this.holdPosition = 1;
                },
                // onReachBeginning: function(swiper){
                //     this.holdPosition = 2;
                // },
                onTouchEnd: function(swiper){
                    if(swiper.translate>0){
                        tabIndex=Number(tabIndex-1);

                        if(tabIndex<0){
                            var test=1;
                            tabIndex=0;
                        }
                        self.$el.find('.recipe_title').eq(tabIndex).addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
                        if(test!=1){
                            var typename=self.$el.find('.recipe_title_on').text();
                            $(".recipe_typename").html(typename);
                            $(".recipe_typename").show();
                        }
                        test =0;
                        setTimeout("$('.recipe_typename').hide('slow')",500);
                        var typeid=self.$el.find('.recipe_title_on').data('typeid');
                        var recipeslist="";
                         if(testData[typeid]){
                            $.each(testData[typeid],function(i,n){
                                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                            });
                            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                            swiper.removeAllSlides();
                            swiper.prependSlide(recipeslist);
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }else{
                            swiper.removeAllSlides();
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }
                    }

                    if(this.holdPosition==1 && swiper.translate<0){
                        tabIndex=Number(tabIndex+1);
                        var max = 0;
                        max=self.$el.find('.recipe_title').size()-1;
                        if(tabIndex>max){
                            var test =1;
                            tabIndex=tabIndex-1;
                        }

                        self.$el.find('.recipe_title').eq(tabIndex).addClass('recipe_title_on').siblings().removeClass('recipe_title_on');
                        var typename=self.$el.find('.recipe_title_on').text();
                        if(test!=1){
                            $(".recipe_typename").html(typename);
                            $(".recipe_typename").show();
                        }
                        test =0;
                        setTimeout("$('.recipe_typename').hide('slow')",500);
                        var typeid=self.$el.find('.recipe_title_on').data('typeid');
                        var recipeslist="";
                        if(testData[typeid]){
                            $.each(testData[typeid],function(i,n){
                                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img  style='height:102px' src='"+n.backimageurl+"'></div>";
                            });
                            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
                            swiper.removeAllSlides();
                            swiper.prependSlide(recipeslist);
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }else{
                            swiper.removeAllSlides();
                            swiper.onResize();
                            swiper.slideTo(0, 1000, false);
                        }

                    }
                }
            });
            var recipeslist="";
            $.each(testData[this.typeid],function(i,n){
                recipeslist += "<div class='swiper-slide' data-recipesid='"+n.id+"'>"+n.name+"<img style='height:102px' src='"+n.backimageurl+"'></div>";
            })
            recipeslist += "<div class='swiper-slide' style='width:100px;background:#efefef;border:0px solid #fff'><div>";
            swiper.prependSlide(recipeslist);
            //供点击事件调用。
            swipers = swiper;
        },
    });
    this.viewIntance = view.getIntance();
})