define(['BaseView', 'Model', 'Store', 'text!TemplatesSet', 'util', 'utilCropImage'], function(BaseView, models, store, tplSet, util, utilCropImage) {

    var isLogin = util.isLogin();
    var userInfoModel = models.userInfoModel;
    var uploadPhotoModel = models.uploadPhotoModel;
    var userUpdateModel = models.userUpdateModel;
    var userQuitModel = models.userQuitModel;
    var headStore = store.headStore;

    if (isLogin) {
        userUpdateModel.url = userUpdateModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
        userQuitModel.url = userQuitModel.url + util.getToken(); //他们的接口有问题必须这么写 不能用access_token
    }

    var view = BaseView.extend({
        viewName: 'set',
        events: {
            'click .js_loginout': 'loginOut',
            'click .js_modifyInfo': 'modifyInfo',
            'click .js_toSafety': 'toSafety',
            'click .js_comment': 'toComment',
            'click .js_feedback': 'toFeedback',
            'click .js_myaa' : 'tomyaa'
        },
        tomyaa:function(e){
            this.jump(['views/myaa.html'].join(''));
        },
        render: function(html) {
            this.$el.html(html);
        },
        onShow: function() {
            if (!isLogin) {
                this.jump(['views/login_phone.html', '?from=views/', this.viewName, '.html'].join(''));
                return;
            }
            this.showLoading();
            userInfoModel.setParam({
                access_token: util.getToken()
            });
            userInfoModel.excute(function(json) {
                this.hideLoading();
                //仅ios和安卓版本有评价我们功能，H5版本没有评价我们的功能
                json.result.isInApp = Turtle.isInApp;
                this.render(_.template(tplSet)(json.result));
                this.changeHeadInit();

            }, function(msg) {
                this.hideLoading();
                this.jump(['views/error.html?from=views/', this.viewName, '.html'].join(''));
            }, false, this);

        },
        changeHeadInit: function() {
            var self = this;
            var options = {
                imageBox: '.imageBox',
                thumbBox: '.thumbBox',
                spinner: '.spinner',
                imgSrc: ''
            }
            var cropper;
            this.$el.find('#fileInput').on('change', function() {
                var reader = new FileReader();
                reader.onload = function(e) {
                    options.imgSrc = e.target.result;
                    cropper = new utilCropImage.cropbox(options);
                }
                reader.readAsDataURL(this.files[0]);
                this.files = [];
                self._toggleCrop();
            });
            $('#btnCrop').on('click', function() {
                cropper.zoomIns();
                var imgBase64 = cropper.getDataURL();
                self.uploadPhoto(imgBase64);
            });
            $('#btnZoomIn').on('click', function() {
                cropper.zoomIn();
            });
            $('#btnZoomOut').on('click', function() {
                cropper.zoomOut();
            });
            $('.js_close').on('click', function() {
                self._toggleCrop();
                self.$el.find('#fileInput').val('');
            });
        },
        _toggleCrop: function() {
            this.$el.find('.js_uploadPage').toggleClass('none');
        },
        uploadPhoto: function(imgBase64) {
            this.showLoading();
            uploadPhotoModel.setParam({
                file: imgBase64
            });
            uploadPhotoModel.excute(function(json) {
                this.hideLoading();
                this._toggleCrop();
                this.$el.find('#fileInput').val('');
                this.$el.find('.js_headImg').data('url', json.result).attr('src', imgBase64);
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        modifyInfo: function() {
            var _sImgUrl = this.$el.find('.js_headImg').data('url');
            var _sIntro = this.$el.find('.js_intro').val();
            this.showLoading();
            userUpdateModel.setParam({
                head: _sImgUrl,
                introduction: _sIntro
            });
            userUpdateModel.excute(function(json) {
                this.hideLoading();
                this.showToast(json.message);
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        loginOut: function() {
            var self = this;
            this.showLoading();
            userQuitModel.excute(function(json) {
                this.hideLoading();
                this.showToast('您已退出', {
                    'hideAction': function() {
                        headStore.setAttr('username', '');
                        headStore.setAttr('token', '');
                        self.jump(['views/article.html'].join(''));
                    }
                });
            }, function(msg) {
                this.hideLoading();
                if (_.isObject(msg) && msg.message) {
                    this.showToast(msg.message);
                    return;
                }
                this.showToast('网络错误，请稍候重试。');
            }, false, this);
        },
        toSafety: function(e) {
            this.jump(['views/safety.html?from=views/', this.viewName, '.html'].join(''));
        },
        toComment: function(e) {
            var deviceIsAndroid = navigator.userAgent.indexOf('Android');
            var deviceIsIOS = /iP(ad|hone|od)/.test(navigator.userAgent);
            if (deviceIsAndroid) {
                plus.runtime.openURL('http://apk.hiapk.com/appinfo/com.ourslook.baked')
                return;
            }
            if (deviceIsIOS) {
                plus.runtime.openURL('https://itunes.apple.com/us/app/mian-fen-rang-hong-bei-bian/id1008570749?l=zh&ls=1&mt=8')
                return;
            }
        },
        toFeedback: function(e) {
            this.jump(['views/feedback.html?from=views/', this.viewName, '.html'].join(''));
        },
        updateHeader: function() {
            var self = this;
            this.headerView.set({
                view: this,
                leftHandler: [{
                    className: "icon back2",
                    event: function(event) {
                        self.jump(['views/article.html'].join(''));
                    }
                }],
                centerHandler: [{
                    title: "我的",
                    className: "title"
                }],
                rightHandler: [{

                }]
            });
            this.headerView.show();
        }
    });

    this.viewIntance = view.getIntance();
});