﻿define(['model', 'util'], function(model, util) {
    var host = util.getHost();

    var createModel = function(url, opt) {
        var deafultOpt = {
            url: host + url
        };

        if (opt) {
            deafultOpt = _.extend(deafultOpt, opt);
        }

        return model.newInstance([deafultOpt]);
    }
    var modelInterface = {};


    // 返回服务网点列表
    // modelInterface.getStationList = createModel("/service/station/list/");
    //食谱步奏
    modelInterface.getRecipesStepModel = createModel("/recipes/step/");
     //食谱用料
    modelInterface.getRecipesMaterialsModel = createModel("/recipes/materials/");
    //
    modelInterface.getTextMwaitModel = createModel("/text/mwait/");
    //
    modelInterface.getTextMendModel = createModel("/text/mend/");
    //
    modelInterface.getTextAcendModel = createModel("/text/acend/");
    //
    modelInterface.getTextAcsendModel = createModel("/text/acsend/");
    //获取文章列表
    modelInterface.getArticleListsModel = createModel("/article/lists2/");
    //获取文章详情
    modelInterface.getArticleDetailModel = createModel("/article/detail2/");
    //文章删除
    modelInterface.articleDeleteModel = createModel("/article/delete/");
    //获取达人列表
    modelInterface.getExpertListsModel = createModel("/expert/lists/");
    //获取达人详情
    modelInterface.getExpertDetailModel = createModel("/expert/detail/");
    //获取活动列表
    modelInterface.getActivityListsModel = createModel("/activity/lists2/");
    //获取活动详情
    modelInterface.getActivityDetailModel = createModel("/activity/detail2/");
    //获取活动评论列表
    modelInterface.getActivityCommentListModel = createModel("/activity/commentlist/");
    //发布活动评论
    modelInterface.sendActivityCommentModel = createModel("/activity/sendcomment/");
    //活动报名
    modelInterface.getActivityRegModel = createModel("/activity/reg2/");
    //发布活动
    modelInterface.getActivityPublishModel = createModel("/activity/publish2/");
    //获取省市区
    modelInterface.getBaseAreas = createModel("/base/areas/");
    //获得商家信息
    modelInterface.getMerchantDetailModel = createModel("/merchant/detail/");
    //地图商家列表
    modelInterface.getMapMerchantModel = createModel("/merchant/maplist/");
    //申请商家信息
    modelInterface.getMerchantPublishModel = createModel("/merchant/publish/");
    //发送手机验证码
    modelInterface.sendSmsCodeModel = createModel("/user/send_sms_code/");
    //手机注册
    modelInterface.mobileRegisterModel = createModel("/user/mobile_register/");
    //个人信息接口
    modelInterface.userInfoModel = createModel("/user/detail/");
    //我的专享
    modelInterface.getActivityMyaaModel = createModel("/activity/myaa/");

    //修改密码
    modelInterface.resetPwdModel = createModel("/user/reset_pwd/");
    //个人设置
    modelInterface.userUpdateModel = createModel("/user/update/");
    //退出登录
    modelInterface.userQuitModel = createModel("/user/quit/");
    //意见反馈
    modelInterface.userFeedbackModel = createModel("/user/user_feedback/");
    //获取 access_token (登陆)
    modelInterface.getAccessTokenModel = createModel("/base/access_token/");
    //线下活动报名表
    modelInterface.activityRegLineModel = createModel("/user/activity_reg_line");
    //获取基础信息配置
    modelInterface.getConfigModel = createModel("/base/config/");
    //上传图片
    modelInterface.uploadPhotoModel = createModel("/base/upload_base64/");
    //烤饼干接口
    modelInterface.bakeGameModel = createModel("/game/bakecookies/");
	//抢饼干接口
    modelInterface.userBackModel = createModel("/game/userback/");
    //抢饼干接口
    modelInterface.gameTakeModel = createModel("/game/gametake/");
    //食谱
    modelInterface.getRecipesIndexModel = createModel("/recipes/index/");
    //步骤
    modelInterface.getRecipesStepModel = createModel("/recipes/step/");
    //用料
    modelInterface.getRecipesMaterialsModel = createModel("/recipes/materials/");
    //忘记密码发送手机验证码
    modelInterface.sendSmsForgetModel = createModel("/user/send_sms_forget/");
    //修改密码
    modelInterface.forgetPasswordModel = createModel("/user/forget_password/");
    //分享成功
    modelInterface.baseshare = createModel("/base/share/");

    return modelInterface;
});