define(function () {

	function SelectDate(option){
		this.$warp = option.$warp;
		this.count = option.count;
		this.height = option.height;
		this.selecdIndex = option.selecdIndex || 0;
		this.index = this.selecdIndex;
		this.$el = option.$el;
		this.attr = option.attr;
		this.className = option.className;
        this.classDisable = option.classDisable;
        this.cascade = option.cascade || null;
        this.isRepair = option.isRepair || false;
        this.callback = option.callback;
		this.init();
	}

	SelectDate.prototype = {
		constructor: SelectDate,
		init: function () {
            this.layer();
            this.bidnEvent();
        },
        layer: function () {
        	var h = this.height,
                top = h * 2;

            this.top = top;
            this.$el.css({ height: this.count * h, top: top - this.selecdIndex * h});
        },
        restStyle: function () {
            var $warp = this.$warp,
        		day = new Date($warp.data('year'), $warp.data('month'), 0).getDate(),
        		index = this.index,
        		classDisable = this.classDisable,
        		$el = this.cascade.$el,
        		$li = $el.find('li'),
        		count = this.cascade.count,
        		h = this.cascade.height,
        		top = h * 2;

        	$el.css({ height: count * h, top: top});
        	$li.eq(0).addClass(this.className);

        	for (var i = 0; i < count; i++) {
        		if ( i < day) {
        			$li.eq(i).removeClass(classDisable);
        		} else {
        			$li.eq(i).addClass(classDisable);
        		}
            }
        },
        restIndex: function(){
        	var $warp = this.$warp,
        		day = new Date($warp.data('year'), $warp.data('month'), 0).getDate(),
        		index = this.index;

        	if (day != 31) {
        		if (index >= day - 1) {
        			this.index = day -1;
        		}
        	}
        },
        bidnEvent: function (){
			var self = this;

            this.$el.on('touchstart', $.proxy(self.start, self), false);
            this.$el.on('touchmove', $.proxy(self.move, self), false);
            this.$el.on('touchend', $.proxy(self.end, self), false);
        },
        start: function (event) {
        	event.preventDefault(); // 阻止触摸事件的默认动作,即阻止滚屏
            var touch = event.touches[0];

            this.startPos = {    // 取第一个touch的坐标值
                x: touch.pageX,
                y: touch.pageY,
                time: +new Date
            };
        },
        move: function (event) {
            event.preventDefault();
            if (event.touches.length > 1 || event.scale && event.scale !== 1) return;
            var touch = event.touches[0];

            this.endPos = {
                x: touch.pageX - this.startPos.x,
                y: touch.pageY - this.startPos.y
            };

            this.$el.css({ top: this.top - this.index * this.height + this.endPos.y });
        },
        end: function (event) {
        	event.preventDefault();
            if (!this.endPos) { return; }

            var duration = +new Date - this.startPos.time,   // 滑动的持续时间
            	endPos = this.endPos,
                step = 1,
                $li = this.$el.find('li'),
                CLASS_NAME = this.className;


            $li.removeClass(CLASS_NAME);
            if (Number(duration) > 100) {
            	step = parseInt(endPos.y / this.height) || step;
            	if (endPos.y > 50) {
            		if (this.index - step <= 0) {
                        this.index = 0;
                    } else {
                        this.index += -step;
                    }
            	} else if (endPos.y < -50) {
            		if (this.index - step >= this.count - 1) {
                        this.index = this.count - 1;
                    } else {
                        this.index += -step;
                    }
            	}
            }

            if(!this.isRepair) {
            	this.$el.animate({ top: this.top - this.index * this.height }, 200);
            	$li.eq(this.index).addClass(CLASS_NAME);
            }

            // 记录选择时间
            this.$warp.data(this.attr, this.$el.find('li[class="current"]').data(this.attr));

            // 级联修复样式
            if (this.cascade) {
            	this.restStyle();
            }

            // 修改索引
            if (this.isRepair) {
            	this.restIndex();
            	this.$el.animate({ top: this.top - this.index * this.height }, 200);
            	$li.eq(this.index).addClass(CLASS_NAME);

                // 修复日
                this.$warp.data(this.attr, this.$el.find('li[class="current"]').data(this.attr));
            }

            this.callback && this.callback();
        }
	};

	return SelectDate;
});

   /*!
 * jQuery Cookie Plugin v1.4.0
 * https://github.com/carhartl/jquery-cookie
 *
 * Copyright 2013 Klaus Hartl
 * Released under the MIT license
 */
(function (factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as anonymous module.
        define(['jquery'], factory);
    } else {
        // Browser globals.
        factory(jQuery);
    }
}(function ($) {

    var pluses = /\+/g;

    function encode(s) {
        return config.raw ? s : encodeURIComponent(s);
    }

    function decode(s) {
        return config.raw ? s : decodeURIComponent(s);
    }

    function stringifyCookieValue(value) {
        return encode(config.json ? JSON.stringify(value) : String(value));
    }

    function parseCookieValue(s) {
        if (s.indexOf('"') === 0) {
            // This is a quoted cookie as according to RFC2068, unescape...
            s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
        }

        try {
            // Replace server-side written pluses with spaces.
            // If we can't decode the cookie, ignore it, it's unusable.
            s = decodeURIComponent(s.replace(pluses, ' '));
        } catch(e) {
            return;
        }

        try {
            // If we can't parse the cookie, ignore it, it's unusable.
            return config.json ? JSON.parse(s) : s;
        } catch(e) {}
    }

    function read(s, converter) {
        var value = config.raw ? s : parseCookieValue(s);
        return $.isFunction(converter) ? converter(value) : value;
    }

    var config = $.cookie = function (key, value, options) {

        // Write
        if (value !== undefined && !$.isFunction(value)) {
            options = $.extend({}, config.defaults, options);

            if (typeof options.expires === 'number') {
                var days = options.expires, t = options.expires = new Date();
                t.setDate(t.getDate() + days);
            }

            return (document.cookie = [
                encode(key), '=', stringifyCookieValue(value),
                options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
                options.path    ? '; path=' + options.path : '',
                options.domain  ? '; domain=' + options.domain : '',
                options.secure  ? '; secure' : ''
            ].join(''));
        }

        // Read

        var result = key ? undefined : {};

        // To prevent the for loop in the first place assign an empty array
        // in case there are no cookies at all. Also prevents odd result when
        // calling $.cookie().
        var cookies = document.cookie ? document.cookie.split('; ') : [];

        for (var i = 0, l = cookies.length; i < l; i++) {
            var parts = cookies[i].split('=');
            var name = decode(parts.shift());
            var cookie = parts.join('=');

            if (key && key === name) {
                // If second argument (value) is a function it's a converter...
                result = read(cookie, value);
                break;
            }

            // Prevent storing a cookie that we couldn't decode.
            if (!key && (cookie = read(cookie)) !== undefined) {
                result[name] = cookie;
            }
        }

        return result;
    };

    config.defaults = {};

    $.removeCookie = function (key, options) {
        if ($.cookie(key) !== undefined) {
            // Must not alter options, thus extending a fresh object...
            $.cookie(key, '', $.extend({}, options, { expires: -1 }));
            return true;
        }
        return false;
    };

}));
