﻿define(['Store'], function(store) {

    var util = {
        getEnvCode: function() {
            var host = location.host;

            if (host.match(/218.244.146.56/) || host.match(/^(localhost)/i)) {
                return 0; // 测试
            } else if (host.match(/i.mianfen.com:1001/)) {
                return 1; // UAT
            } else {
                return 2; // online
            }
        },
        getHost: function() {
            var modelUrl = ['http://121.41.78.242/api', 'http://121.41.78.242/api', 'http://121.41.78.242/api'],
                devHost = '', // 调试本机接口
                env = this.getEnvCode();

            if (env == 0 && devHost != '') {
                return devHost;
            }
            return modelUrl[env];
        },
        getUserInfo: function() {
            var headStore = store.headStore;
            if (headStore) {
                return headStore.getAttr('userinfo');
            }
            return null;
        },
        getUserName: function() {
            var headStore = store.headStore;
            if (headStore) {
                return headStore.getAttr('username');
            }
            return null;
        },
        getToken: function() {
            var headStore = store.headStore;
            if (headStore) {
                return headStore.getAttr('token');
            }
            return null;
        },
        isLogin: function() {
            if (this.getToken()) {
                return true;
            }
            return false;
        },

        // getAppid: function () {
        //     var appId = ['wx5a684fd0fafb662d', 'wx0808c7150754d8d1', 'wxa83640d822028913'],
        //         env = this.getEnvCode();

        //     return appId[env];
        // },
        // getImgUrl: function (url, width, heighth) {
        //     var netWorkType = Turtle._netWorkType,
        //         definition;

        //     switch (netWorkType) {
        //         case '2g':
        //             definition = '/blur/10x1';
        //             break;
        //         case '3g':
        //             definition = '/blur/30x1';
        //             break;
        //         case '4g':
        //         case 'wifi':
        //             definition = '';
        //     }

        //     return url + '?imageView2/0/w/' + width + '/h/' + heighth + definition;
        // }
    }

    return util;
});